#include "common.h"
#include "ArchiverCAB.h"
#include "../util.h"
#include "../ConfigCode/config.h"
#include "../resource.h"

CArchiverCAB::CArchiverCAB()
{
//	TRACE(_T("CArchiverCAB()\n"));
//	Separator=_T('\\');
	m_nRequiredVersion=98;
	m_strDllName=_T("CAB32.DLL");
	m_AstrPrefix="Cab";
	m_AstrFindParam="**";
	//LOAD_DLL_STANDARD/*_WITHOUT_GETATTRIBUTE*/
}

CArchiverCAB::~CArchiverCAB()
{
//	TRACE(_T("~CArchiverCAB()\n"));
	FreeDLL();
}

bool CArchiverCAB::Compress(LPCTSTR ArcFileName,std::list<CString> &ParamList,CConfigManager &Config,const PARAMETER_TYPE,int Options,CString &strLog)
{
	if(!IsOK()){
		return false;
	}

	ASSERT(0!=_tcslen(ArcFileName));
	TRACE(_T("ArcFileName=%s\n"),ArcFileName);

	//==============================================
	// X|Xt@Cpe|t@C擾
	//==============================================
	TCHAR ResponceFileName[_MAX_PATH+1];
	FILL_ZERO(ResponceFileName);
	if(!UtilGetTemporaryFileName(ResponceFileName,_T("cab"))){
		ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_TEMPORARY_FILE_CREATE)));
		return false;
	}
	ASSERT(0!=_tcslen(ResponceFileName));

	//============================================
	// ȉ𓀃t@Cpe|t@C擾
	//============================================
	TCHAR SFXTemporaryFileName[_MAX_PATH+1];
	FILL_ZERO(SFXTemporaryFileName);
	bool bSFX=(0!=(Options&COMPRESS_SFX));
	if(bSFX){
		//3iK쐬
		if(!UtilGetTemporaryFileName(SFXTemporaryFileName,_T("sfx"))){
			ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_TEMPORARY_FILE_CREATE)));
			return false;
		}
		ASSERT(0!=_tcslen(SFXTemporaryFileName));
		DeleteFile(SFXTemporaryFileName);//S~t@C

		PathRemoveExtension(SFXTemporaryFileName);
		PathAddExtension(SFXTemporaryFileName,_T(".cab"));
	}

	//======================================================
	// X|Xt@CɈkΏۃt@CL
	// A[JCut@C̓R}hCŒڎw肷
	// TutH_̃t@Cڎw肵ĂBDLL
	// ċNɗƗ\Õt@C܂ňkΏۂɂ
	//======================================================
	{
		HANDLE hFile=CreateFile(ResponceFileName,GENERIC_WRITE,0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
		if(INVALID_HANDLE_VALUE==hFile)
		{
			ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_TEMPORARY_FILE_ACCESS)));
			return false;
		}

		TRACE(_T("X|Xt@Cւ̏\n"));
		std::list<CString>::iterator ite;
		for(ite=ParamList.begin();ite!=ParamList.end();ite++){
			if(PathIsDirectory(*ite)){
				EnumAndWriteSubDir(hFile,*ite);
			}
			else WriteResponceFile(hFile,*ite);
		}
		CloseHandle(hFile);
	}

	//===========================
	// DLLɓnIvV̐ݒ
	//===========================
	TRACE(_T("DLLɓnIvV̐ݒ\n"));

	CString Param;//R}hC p[^ obt@

	//kp[^
	Param+=_T("-a ");	//k
//	Param+=_T("-r ");	//ċNIɏ	LhaForgeŃt@C񋓂邱ƂőΏ

	Config.LoadConfig(CONFIG_CAB);
	switch(Config.CAB.CompressType){
	case CAB_COMPRESS_MSZIP:
		Param+=_T("-mz ");	//MSZIP`ňk
		break;
	case CAB_COMPRESS_LZX:
		Param+=_T("-ml:");	//LZX`
		{
			CString buf;
			buf.Format(_T("%d"),Config.CAB.LZX_Level);
			Param+=buf;
		}
		Param+=_T(" ");
		break;
	case CAB_COMPRESS_PLAIN:
		Param+=_T("-ms ");	//k
		break;
	}

	//kt@Cw
	if(bSFX){
		Param+=_T("\"");
		Param+=SFXTemporaryFileName;
		Param+=_T("\" ");
	}
	else{
		Param+=_T("\"");
		Param+=ArcFileName;
		Param+=_T("\" ");
	}

	//X|Xt@Cw
	Param+=_T("\"@");
	Param+=ResponceFileName;
	Param+=_T("\"");

	ASSERT(!Param.IsEmpty());
	TRACE(_T("ArchiveHandler Commandline Parameter:%s\n"),Param);

	TRACE(_T("ArchiveHandlerĂяo\n"));
	//char szLog[LOG_BUFFER_SIZE]={0};
	std::vector<char> szLog(LOG_BUFFER_SIZE);
	szLog[0]='\0';
	int Ret=ArchiveHandler(NULL,CT2A(Param),&szLog[0],LOG_BUFFER_SIZE-1);
	strLog=&szLog[0];

	//gX|Xt@C͏
	DeleteFile(ResponceFileName);

	//G[Oo
	if(!bSFX||0!=Ret){
		if(bSFX){
			DeleteFile(SFXTemporaryFileName);
		}
		return 0==Ret;
	}

	//====================
	// ȉ𓀏ɂɕϊ
	//====================
	//ϊp[^
	Param=_T("-f ");		//ϊ
	Param+=_T("\"");
	Param+=SFXTemporaryFileName;	//ϊt@C
	Param+=_T("\" ");

	//----------
	//o͐tH_
	TCHAR Buffer[_MAX_PATH+1];
	FILL_ZERO(Buffer);
	GetTempPath(_MAX_PATH,Buffer);
	PathAddBackslash(Buffer);

	Param+=_T(" \"");
	Param+=Buffer;
	Param+=_T("\" ");

	ASSERT(!Param.IsEmpty());
	TRACE(_T("ArchiveHandler Commandline Parameter(SFX):%s\n"),Param);

	TRACE(_T("SFXpArchiveHandlerĂяo\n"));
	std::vector<char> LogSFX(LOG_BUFFER_SIZE);
	LogSFX[0]='\0';
	Ret=ArchiveHandler(NULL,CT2A(Param),&LogSFX[0],LOG_BUFFER_SIZE-1);
	strLog+=&LogSFX[0];
	DeleteFile(SFXTemporaryFileName);

	if(!Ret){	//ꍇAt@CύX
		//܂͕ϊꂽȉ𓀃t@C쐬
		PathStripPath(SFXTemporaryFileName);
		PathRemoveExtension(SFXTemporaryFileName);
		PathAddExtension(SFXTemporaryFileName,_T(".exe"));
		PathAppend(Buffer,SFXTemporaryFileName);
//		TRACE(_T("***%s\n",Buffer));
		//t@Cړ
		MoveFile(Buffer,ArcFileName);
	}

	return 0==Ret;
}

//t@C𓀁Gʏ
bool CArchiverCAB::Extract(LPCTSTR ArcFileName,CConfigManager &Config,bool bSafeArchive,LPCTSTR OutputDir,CString &strLog)
{
	if(!IsOK()){
		return false;
	}

	if(!bSafeArchive){
		CString msg;
		msg.Format(IDS_ASK_CONTINUE_EXTRACT_USING_ALTERNATIVE_METHOD,ArcFileName);
		if(IDYES==MessageBox(NULL,msg,UtilGetMessageCaption(),MB_YESNO|MB_ICONQUESTION)){
			return ExtractAlternative(ArcFileName,Config,OutputDir,strLog);
		}
		else{
			return false;
		}
	}

	//===========================
	// DLLɓnIvV̐ݒ
	//===========================
	TRACE(_T("DLLɓnIvV̐ݒ\n"));

	CString Param;//R}hC p[^ obt@

	//𓀃p[^
	Param+=_T("-x ");		//
//	Param+=_T("-k ");		//}`{[;߂

	if(Config.Common.Extract.ForceOverwrite){
		//㏑
		Param+=_T("-o ");
	}

	//A[JCut@Cw
	Param+=_T("\"");
	Param+=ArcFileName;
	Param+=_T("\" ");

	//o͐w
	Param+=_T("\"");
	Param+=OutputDir;
	Param+=_T("\"");

	ASSERT(!Param.IsEmpty());
	TRACE(_T("ArchiveHandler Commandline Parameter:%s\n"),Param);

	TRACE(_T("ArchiveHandlerĂяo\n"));
	//char szLog[LOG_BUFFER_SIZE]={0};
	std::vector<char> szLog(LOG_BUFFER_SIZE);
	szLog[0]='\0';
	int Ret=ArchiveHandler(NULL,CT2A(Param),&szLog[0],LOG_BUFFER_SIZE-1);
	strLog=&szLog[0];

	return 0==Ret;
}

//t@C𓀁GᑬS
bool CArchiverCAB::ExtractAlternative(LPCTSTR ArcFileName,CConfigManager &Config,LPCTSTR ExtractBaseDirectory,CString &strLog)
{
	TRACE(_T("ExtractAlternative() called.\n"));
	if(!IsOK()){
		return false;
	}

	//===========================
	// DLLɓnIvV̐ݒ
	//===========================
	CString ParamOrg;//R}hC p[^ obt@(ʕ)

	//𓀃p[^
	ParamOrg+=_T("-x ");		//
	ParamOrg+=_T("-j ");		//tH_𖳎Ĉk܂͉
	if(Config.Common.Extract.ForceOverwrite){
		//㏑
		ParamOrg+=_T("-o ");
	}

	//A[JCut@Cw
	ParamOrg+=_T("\"");
	ParamOrg+=ArcFileName;
	ParamOrg+=_T("\" ");

	//===================================================
	// A[JCũt@C񋓂A
	// CAB32.DLL̉𓀃[`Ƀt@CPʂŉ𓀂
	//===================================================
	if(!InspectArchiveBegin(ArcFileName)){
		CString msg;
		msg.Format(IDS_ERROR_OPEN_ARCHIVE,ArcFileName);
		ErrorMessage(msg);
		return false;
	}
//	CString Log;	//Oobt@
	strLog.Empty();
	strLog+=_T("Extracting file \"");
	strLog+=ArcFileName;
	strLog+=_T("\" with an alternative method\n\n");

	//SẴt@C
	while(InspectArchiveNext()){
		CString Buffer;	//̃obt@ɓt@C͕KvɉύXĂ
		InspectArchiveGetFileName(Buffer);

		const CString OrgFileName=Buffer;	//i[t@CȂ̂ŕύXȂ

		UtilModifyPath(Buffer);
/*		int Ret=0;
		do{
			Ret=Buffer.Replace(_T("\\\\"),_T("\\"));	//\\\ɒuĂ
		}while(Ret!=0);
		Buffer.Replace(_T("..\\"),_T("__\\"));	//΃pXw..__ɒu
		Buffer.Replace(_T(":"),_T("__"));	//hCuu(C:C__)*/

		//JgfBNg̃pXƍZpXgݍ킹ďo͐fBNg擾
		TCHAR OutputDir[_MAX_PATH+1];
		FILL_ZERO(OutputDir);
		_tcsncpy_s(OutputDir,ExtractBaseDirectory,_MAX_PATH);

		PathAppend(OutputDir,Buffer);
		//---
		//ŏo͐t@CoĂ̂ŃOo͗pɎ؂Ă
		strLog+=OrgFileName;
		strLog+=_T("\n-->Extract as ");
		strLog+=OutputDir;
		strLog+=_T("\n  Result:");
		//---
		PathRemoveFileSpec(OutputDir);
		PathAddBackslash(OutputDir);

		//o͐fBNg쐬Ă
		if(!UtilMakeSureDirectoryPathExists(OutputDir)){
			CString msg;
			msg.Format(IDS_ERROR_CANNOT_MAKE_DIR,OutputDir);
			ErrorMessage(msg);
			strLog+=_T("Failed : Can't create output directory\n\n");
			break;
		}

		CString Parameter=ParamOrg;
		Parameter+=_T("\"");
		Parameter+=OutputDir;
		Parameter+=_T("\" ");

		Parameter+=_T("\"");
		Parameter+=OrgFileName;
		Parameter+=_T("\"");

		TRACE(_T("ArchiveHandlerĂяo\nCommandline Parameter:%s\n"),Parameter);
		int Ret=ArchiveHandler(NULL,CT2A(Parameter),NULL,0);

		strLog+= (0==Ret?_T("Succeed\n\n"):_T("Fail\n\n"));
	}

	InspectArchiveEnd();

/*	//̏ꍇ͋IɃO
	CLogDialog LogDlg;
	LogDlg.SetData(Log);
	LogDlg.DoModal();*/

	return false;
//	return true;
}


//============================================================
// CabGetFileName()̏o͌ʂɁAi[ꂽt@CpX
// Ă邩ǂʂAdtH_쐬h
// 𓀂ĂSǂf
//============================================================
bool CArchiverCAB::ExamineArchive(LPCTSTR ArcFileName,bool,bool &bInFolder,bool &bSafeArchive,CString &BaseDir)
{
	return _ExamineArchive(ArcFileName,bInFolder,bSafeArchive,2,BaseDir);
}


// TufBNgт̒̃t@C񋓂A
// t@CX|Xt@Cɏ
void CArchiverCAB::EnumAndWriteSubDir(HANDLE hFile,LPCTSTR Path)
{
	WIN32_FIND_DATA lp;

	CString Buffer=Path;
	Buffer+=_T("\\*");
	HANDLE h=FindFirstFile(Buffer,&lp);

	do{
		if((lp.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)&& 0!=_tcscmp(lp.cFileName,_T("..")) && 0!=_tcscmp(lp.cFileName,_T(".")))
		{
			CString SubPath=Path;
			SubPath+=_T("\\");
			SubPath+=lp.cFileName;

			EnumAndWriteSubDir(hFile,SubPath);
		}
		if((lp.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)!=FILE_ATTRIBUTE_DIRECTORY)
		{
			// lp.cFileNameŃt@C
			// wsprintf(o͕,"%s%s",temp,lp.cFileName);Ƃ
			// t@C̃tpX
			CString FileName=Path;
			FileName+=_T("\\");
			FileName+=lp.cFileName;

			if(0==_tcsnccmp(FileName,_T(".\\"),2)){
				//JgfBNgw肪΍폜Ă
				FileName.Delete(0,2);
			}

			WriteResponceFile(hFile,FileName);
		}
	}while(FindNextFile(h,&lp));

	FindClose(h);
}

bool CArchiverCAB::ExtractSpecifiedOnly(LPCTSTR ArcFileName,LPCTSTR OutputDir,std::list<CString> &FileList,CString &strLog,bool bUsePath)
{
	if(!IsOK()){
		return false;
	}

	//==============================================
	// X|Xt@Cpe|t@C擾
	//==============================================
	TCHAR ResponceFileName[_MAX_PATH+1];
	FILL_ZERO(ResponceFileName);
	if(!UtilGetTemporaryFileName(ResponceFileName,_T("cab"))){
		ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_TEMPORARY_FILE_CREATE)));
		return false;
	}
	ASSERT(0!=_tcslen(ResponceFileName));

	//𓀑Ώۃt@CX|Xt@Cɏo
	{
		HANDLE hFile=CreateFile(ResponceFileName,GENERIC_WRITE,0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
		if(INVALID_HANDLE_VALUE==hFile)
		{
			ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_TEMPORARY_FILE_ACCESS)));
			return false;
		}

		std::list<CString>::iterator ite=FileList.begin();
		const std::list<CString>::iterator end=FileList.end();
		for(;ite!=end;ite++){
			WriteResponceFile(hFile,*ite);
		}
		CloseHandle(hFile);
	}

	//===========================
	// DLLɓnIvV̐ݒ
	//===========================
	CString Param;

	//𓀃p[^
	Param+=_T("-x ");		//
	if(!bUsePath){
		Param+=_T("-j ");		//tH_𖳎Ĉk܂͉
	}

	//A[JCut@Cw
	Param+=_T("\"");
	Param+=ArcFileName;
	Param+=_T("\" ");

	//o͐tH_
	Param+=_T("\"");
	Param+=OutputDir;
	Param+=_T("\" ");

	//X|Xt@Cw
	Param+=_T("\"@");
	Param+=ResponceFileName;
	Param+=_T("\"");

	//o͐fBNg쐬Ă
	if(!UtilMakeSureDirectoryPathExists(OutputDir)){
		CString msg;
		msg.Format(IDS_ERROR_CANNOT_MAKE_DIR,OutputDir);
		ErrorMessage(msg);
		return false;
	}

	TRACE(_T("ArchiveHandlerĂяo\nCommandline Parameter:%s\n"),Param);
	//char szLog[LOG_BUFFER_SIZE]={0};
	std::vector<char> szLog(LOG_BUFFER_SIZE);
	szLog[0]='\0';
	int Ret=ArchiveHandler(NULL,CT2A(Param),&szLog[0],LOG_BUFFER_SIZE-1);
	strLog=&szLog[0];
	//gX|Xt@C͏
	DeleteFile(ResponceFileName);

	return 0==Ret;
}


ARCRESULT CArchiverCAB::TestArchive(LPCTSTR ArcFileName,CString &strLog)
{
	TRACE(_T("TestArchive() called.\n"));
	ASSERT(IsOK());
	if(!IsOK()){
		return TEST_ERROR;
	}

	//tR}hɂeXgĂ
	CString Param=
		_T("-t ")			//eXg
		_T("\"")
	;
	Param+=ArcFileName;
	Param+=_T("\"");

	//char szLog[LOG_BUFFER_SIZE]={0};
	std::vector<char> szLog(LOG_BUFFER_SIZE);
	szLog[0]='\0';
	int Ret=ArchiveHandler(NULL,CT2A(Param),&szLog[0],LOG_BUFFER_SIZE-1);
	strLog=&szLog[0];

	if(0==Ret){
		strLog+=_T("\r\n");
		strLog+=CString(MAKEINTRESOURCE(IDS_TESTARCHIVE_RESULT_OK));
		return TEST_OK;
	}
	else return TEST_NG;
}
