#include "common.h"
#include "ArchiverUNBEL.h"
#include "../util.h"
#include "../ConfigCode/config.h"
#include "../resource.h"


CArchiverUNBEL::CArchiverUNBEL()
{
//	TRACE(_T("CArchiverUNBEL()\n"));
	m_nRequiredVersion=45;
	m_nRequiredSubVersion=1;
	m_strDllName=_T("Unbel32.DLL");
	m_AstrPrefix="Unbel";
	m_LoadLevel=LOAD_DLL_MINIMUM;
//	LoadLevel=LOAD_DLL_SIMPLE_INSPECTION;
}

CArchiverUNBEL::~CArchiverUNBEL()
{
//	TRACE(_T("~CArchiverUNBEL()\n"));
	FreeDLL();
}

LOAD_RESULT CArchiverUNBEL::LoadDLL(CConfigManager &Config,bool bSilent)
{
	FreeDLL();
	LOAD_RESULT res=CArchiverDLL::LoadDLL(Config,bSilent);
	if(LOAD_RESULT_OK!=res){
		return res;
	}

	CStringA FunctionName=m_AstrPrefix;
	FunctionName+="OpenArchive";
	ArchiverOpenArchive=(COMMON_ARCHIVER_OPENARCHIVE)GetProcAddress(m_hInstDLL,FunctionName);
	if(NULL==ArchiverOpenArchive){
		if(!bSilent){
			CString msg;
			msg.Format(IDS_ERROR_DLL_FUNCTION_GET,m_strDllName,FunctionName);
			ErrorMessage(msg);
		}
		FreeDLL();
		return LOAD_RESULT_INVALID;
	}

	FunctionName=m_AstrPrefix;
	FunctionName+="CloseArchive";
	ArchiverCloseArchive=(COMMON_ARCHIVER_CLOSEARCHIVE)GetProcAddress(m_hInstDLL,FunctionName);
	if(NULL==ArchiverCloseArchive){
		if(!bSilent){
			CString msg;
			msg.Format(IDS_ERROR_DLL_FUNCTION_GET,m_strDllName,FunctionName);
			ErrorMessage(msg);
		}
		FreeDLL();
		return LOAD_RESULT_INVALID;
	}

	//FindFirst
	FunctionName=m_AstrPrefix;
	FunctionName+="FindFirst";
	ArchiverFindFirst=(COMMON_ARCHIVER_FINDFIRST)GetProcAddress(m_hInstDLL,FunctionName);
	if(NULL==ArchiverFindFirst){
		if(!bSilent){
			CString msg;
			msg.Format(IDS_ERROR_DLL_FUNCTION_GET,m_strDllName,FunctionName);
			ErrorMessage(msg);
		}
		FreeDLL();
		return LOAD_RESULT_INVALID;
	}

	//t@C擾
	FunctionName=m_AstrPrefix;
	FunctionName+="GetFileName";
	ArchiverGetFileName=(COMMON_ARCHIVER_GETFILENAME)GetProcAddress(m_hInstDLL,FunctionName);
	if(NULL==ArchiverGetFileName){
		if(!bSilent){
			CString msg;
			msg.Format(IDS_ERROR_DLL_FUNCTION_GET,m_strDllName,FunctionName);
			ErrorMessage(msg);
		}
		FreeDLL();
		return LOAD_RESULT_INVALID;
	}
	return LOAD_RESULT_OK;
}

bool CArchiverUNBEL::Compress(LPCTSTR,std::list<CString>&,CConfigManager&,const PARAMETER_TYPE,int,CString &)
{
	//BEL͉𓀂̂
	ASSERT(false);
	return false;
}

bool CArchiverUNBEL::Extract(LPCTSTR ArcFileName,CConfigManager &Config,bool bSafeArchive,LPCTSTR OutputDir,CString &strLog)
{
	if(!IsOK()){
		return false;
	}
	if(!bSafeArchive){
		//CString msg;
		//msg.Format(IDS_ERROR_DANGEROUS_ARCHIVE,ArcFileName);
		//ErrorMessage(msg);
		strLog.Format(IDS_ERROR_DANGEROUS_ARCHIVE,ArcFileName);
		return false;
	}

	//===========================
	// DLLɓnIvV̐ݒ
	//===========================
	TRACE(_T("DLLɓnIvV̐ݒ\n"));

	CString Param;//R}hC p[^ obt@

	//𓀃p[^͂Ȃ
//	if(Config.Common.Extract.ForceOverwrite){
		//㏑͂łȂ
//	}

	//A[JCut@Cw
	Param+=_T("\"");
	Param+=ArcFileName;
	Param+=_T("\" ");

	//o͐w
	Param+=_T("\"");
	Param+=OutputDir;
	Param+=_T("\"");

	ASSERT(!Param.IsEmpty());
	TRACE(_T("ArchiveHandler Commandline Parameter:%s\n"),Param);

	TRACE(_T("ArchiveHandlerĂяo\n"));
	//char szLog[LOG_BUFFER_SIZE]={0};
	std::vector<char> szLog(LOG_BUFFER_SIZE);
	szLog[0]='\0';
	int Ret=ArchiveHandler(NULL,CT2A(Param),&szLog[0],LOG_BUFFER_SIZE-1);
	strLog=&szLog[0];

	return 0==Ret;
}

//=========================================================
// Belon`̓t@Ci[łȂA
// t@C͊gq3݂̂ێĂȂ
// ADTV͋NB
//=========================================================
bool CArchiverUNBEL::ExamineArchive(LPCTSTR ArcFileName,bool,bool &bInFolder,bool &bSafeArchive,CString &BaseDir)
{
	bInFolder=false;
	if(!IsOK()){
		return false;
	}

	if(!InspectArchiveBegin(ArcFileName)){
		CString msg;
		msg.Format(IDS_ERROR_OPEN_ARCHIVE,ArcFileName);
		ErrorMessage(msg);
		return false;
	}

	CString Buffer;
	InspectArchiveNext();		//Pt@Ĉ݊i[
	InspectArchiveGetFileName(Buffer);
	InspectArchiveEnd();

	Buffer.Replace(_T('\\'),_T('/'));		//pX؂蕶̒u
	TRACE(_T("%s\n"),Buffer);

	if(-1!=Buffer.Find(_T("../"))){
		bSafeArchive=false;
	}
	else{
		bSafeArchive=true;
	}
	return true;
//	return _ExamineArchive(ArcFileName,bInFolder,bSafeArchive,_T("*.*"),_T('\\'),0);
}

bool CArchiverUNBEL::ExtractSpecifiedOnly(LPCTSTR ArcFileName,LPCTSTR OutputDir,std::list<CString>&,CString &,bool bUsePath)
{
	return false;
}

