#pragma once

#include "config.h"
#include "../resource.h"
#include <atlddx.h>		// DDX/DDVgp邽

//====================================
// ZIP̐ݒ荀
//====================================
class CConfigZIP : public CDialogImpl<CConfigZIP>,public CWinDataExchange<CConfigZIP>,public CMessageFilter
{
protected:
	CConfigManager	&Config;

	CButton			Radio_CompressType[ZIP_COMPRESS_TYPE_MAX_NUM];
	CButton			Radio_CompressLevel[ZIP_COMPRESS_LEVEL_MAX_NUM];

	CButton			Check_SpecifyDeflateMemorySize;
	int				DeflateMemorySize;
	CButton			Check_SpecifyDeflatePassNumber;
	int				DeflatePassNumber;
	virtual BOOL PreTranslateMessage(MSG* pMsg){
		return IsDialogMessage(pMsg);
	}

public:
	enum { IDD = IDD_PROPPAGE_CONFIG_ZIP };

	// DDX}bv
	BEGIN_DDX_MAP(CConfigZIP)
		DDX_INT_RANGE(IDC_EDIT_ZIP_DEFLATE_MEMORY_SIZE, DeflateMemorySize, ZIP_DEFLATE_MEMORY_SIZE_LOWEST, ZIP_DEFLATE_MEMORY_SIZE_HIGHEST)
		DDX_INT_RANGE(IDC_EDIT_ZIP_DEFLATE_PASS_NUMBER, DeflatePassNumber, ZIP_DEFLATE_PASS_NUMBER_LOWEST, ZIP_DEFLATE_PASS_NUMBER_HIGHEST)
	END_DDX_MAP()

	// bZ[W}bv
	BEGIN_MSG_MAP_EX(CConfigZIP)
		MSG_WM_INITDIALOG(OnInitDialog)
		COMMAND_ID_HANDLER(IDC_CHECK_ZIP_SPECIFY_MEMORY_SIZE,OnSpecifyDeflateMemorySize)
		COMMAND_ID_HANDLER(IDC_CHECK_ZIP_SPECIFY_PASS_NUMBER,OnSpecifyDeflatePassNumber)
		MSG_WM_DESTROY(OnDestroy)
	END_MSG_MAP()

	LRESULT OnInitDialog(HWND hWnd, LPARAM lParam);
	LRESULT OnApply();
	LRESULT OnSpecifyDeflateMemorySize(WORD,WORD,HWND,BOOL&);
	LRESULT OnSpecifyDeflatePassNumber(WORD,WORD,HWND,BOOL&);

	void OnDataValidateError(UINT nCtrlID, BOOL bSave, _XData& data){
		CString msg; 
		msg.Format(IDS_ERROR_VALUE_RANGE,data.intData.nMin, data.intData.nMax);
		ErrorMessage(msg);

		::SetFocus(GetDlgItem(nCtrlID));
		::SendMessage(GetDlgItem(nCtrlID),EM_SETSEL,0,-1);
	}

	CConfigZIP(CConfigManager &cfg):
		DeflateMemorySize(0),
		DeflatePassNumber(0),
		Config(cfg)
	{
		TRACE(_T("CConfigZIP()\n"));
	}

	LRESULT OnDestroy(){
		CMessageLoop* pLoop = _Module.GetMessageLoop();
		pLoop->RemoveMessageFilter(this);

		return TRUE;
	}
};

