#include "common.h"
#include "configwnd.h"


CConfigDialog::CConfigDialog(CConfigManager &cfg)
	:Config(cfg),
	hActiveDialogWnd(NULL),
	PageGeneral(cfg),
	PageShellExt(cfg,*this),
	PageCompressGeneral(cfg),
	PageExtractGeneral(cfg),
	PageAssociation(*this),
	PageLZH(cfg),
	PageZIP(cfg),
	PageCAB(cfg),
	Page7Z(cfg),
	PageTAR(cfg),
	PageJACK(cfg),
//	PageBH(cfg),
//	PageYZ1(cfg),
//	PageYZ2(Config),
	PageHKI(cfg),
	PageBGA(cfg),
	PageAISH(cfg),
	PageXACRETT(cfg),
	PageB2E(cfg),
	PageDLLUpdate(cfg),
	PageOpenAction(cfg),
	PageFileListWindow(cfg),
	m_nAssistRequireCount(0)
{
	TRACE(_T("CConfigDialog()\n"));

	//e|INIt@C擾
	TCHAR szIniName[_MAX_PATH+1]={0};
	UtilGetTemporaryFileName(szIniName,_T("lhf"));
	m_strAssistINI=szIniName;

	//ݒǂݍ
	Config.LoadConfig(CONFIG_LOAD_ALL);
}

CConfigDialog::~CConfigDialog()
{
}


LRESULT CConfigDialog::OnInitDialog(HWND hWnd, LPARAM lParam)
{
	// 傫ACRݒ
	HICON hIcon = AtlLoadIconImage(IDI_APP, LR_DEFAULTCOLOR,::GetSystemMetrics(SM_CXICON),::GetSystemMetrics(SM_CYICON));
	SetIcon(hIcon, TRUE);

	// ACRݒ
	HICON hIconSmall = AtlLoadIconImage(IDI_APP, LR_DEFAULTCOLOR,::GetSystemMetrics(SM_CXSMICON), ::GetSystemMetrics(SM_CYSMICON));
	SetIcon(hIconSmall, FALSE);

	//vpeBV[g\t邽߂̃XN[Rei̔zuꏊ擾
	CStatic StaticFrame;
	StaticFrame=GetDlgItem(IDC_STATIC_FRAME);
	RECT rect;
	StaticFrame.GetWindowRect(&rect);
//	StaticFrame.ShowWindow(SW_HIDE);
	ScreenToClient(&rect);

	//XN[Reizu
	ScrollWindow.Create(m_hWnd,rect,NULL,/*WS_TABSTOP|*/WS_CHILD|WS_VISIBLE , WS_EX_CLIENTEDGE|WS_EX_CONTROLPARENT);

	//--------------------
	// c[r[̐ݒ
	//--------------------
	SelectTreeView=GetDlgItem(IDC_TREE_SELECT_PROPPAGE);

#define ADD_PAGE(_DIALOG,_ROOTITEM) {\
	_DIALOG.Create(ScrollWindow);\
	TCHAR Buffer[_MAX_PATH+1]={0};\
	_DIALOG.GetWindowText(Buffer,_MAX_PATH);\
	HTREEITEM hItem=SelectTreeView.InsertItem(Buffer, _ROOTITEM, TVI_LAST);\
	SelectTreeView.SetItemData(hItem,(DWORD_PTR)_DIALOG.m_hWnd);\
}

	//--------------------------------
	// _CAȌǉĂ
	//--------------------------------
	ADD_PAGE(PageGeneral,TVI_ROOT);
	ADD_PAGE(PageShellExt,TVI_ROOT);
	ADD_PAGE(PageShortcut,TVI_ROOT);
	ADD_PAGE(PageFileListWindow,TVI_ROOT);
	ADD_PAGE(PageCompressGeneral,TVI_ROOT);
	ADD_PAGE(PageExtractGeneral,TVI_ROOT);
	ADD_PAGE(PageAssociation,TVI_ROOT);
	ADD_PAGE(PageOpenAction,TVI_ROOT);
//	ADD_PAGE(PageAssociation2,TVI_ROOT);
	ADD_PAGE(PageDLLUpdate,TVI_ROOT);
	ADD_PAGE(PageVersion,TVI_ROOT);

	//----------------
	// ȉ͏ڍאݒ
	//----------------
	//c[̐e
	PageDetail.Create(ScrollWindow);
	HTREEITEM hItemDetail;
	{
		TCHAR Buffer[_MAX_PATH+1]={0};
		PageDetail.GetWindowText(Buffer,_MAX_PATH);
		hItemDetail=SelectTreeView.InsertItem(Buffer, TVI_ROOT, TVI_LAST);
	}
	SelectTreeView.SetItemData(hItemDetail,(DWORD_PTR)PageDetail.m_hWnd);

	ADD_PAGE(PageLZH,hItemDetail);
	ADD_PAGE(PageZIP,hItemDetail);
	ADD_PAGE(PageCAB,hItemDetail);
	ADD_PAGE(Page7Z,hItemDetail);
	ADD_PAGE(PageTAR,hItemDetail);
	ADD_PAGE(PageJACK,hItemDetail);
//	ADD_PAGE(PageBH,hItemDetail);
//	ADD_PAGE(PageYZ1,TVI_ROOT);
	ADD_PAGE(PageHKI,hItemDetail);
	ADD_PAGE(PageBGA,hItemDetail);
	ADD_PAGE(PageAISH,hItemDetail);
	ADD_PAGE(PageXACRETT,hItemDetail);
	ADD_PAGE(PageB2E,hItemDetail);

	//------------------------
	// ͂߂ɕ\y[W
	//------------------------
	PageGeneral.ShowWindow(SW_SHOW);
	ScrollWindow.SetClient(PageGeneral);
	hActiveDialogWnd=PageGeneral;
	SelectTreeView.SetFocus();

	// _CAOTCY
	DlgResize_Init(true, true, WS_THICKFRAME | WS_CLIPCHILDREN);

	//---[U[ԋʐݒ?
	if(Config.IsUserCommon()){
		//EBhE^Cgݒ
		SetWindowText(CString(MAKEINTRESOURCE(IDS_CAPTION_CONFIG_USERCOMMON)));
	}

	return TRUE;
}

void CConfigDialog::OnOK(UINT uNotifyCode, int nID, HWND hWndCtl)
{
	//e_CAOOnApplyĂ
	bool bRet=true;
	bRet=bRet&&PageGeneral.OnApply();
	bRet=bRet&&PageShellExt.OnApply();
	bRet=bRet&&PageCompressGeneral.OnApply();
	bRet=bRet&&PageExtractGeneral.OnApply();
	bRet=bRet&&PageLZH.OnApply();
	bRet=bRet&&PageZIP.OnApply();
	bRet=bRet&&PageCAB.OnApply();
	bRet=bRet&&Page7Z.OnApply();
	bRet=bRet&&PageTAR.OnApply();
	bRet=bRet&&PageJACK.OnApply();
	bRet=bRet&&PageHKI.OnApply();
	bRet=bRet&&PageBGA.OnApply();
	bRet=bRet&&PageAISH.OnApply();
	bRet=bRet&&PageXACRETT.OnApply();
	bRet=bRet&&PageB2E.OnApply();
	bRet=bRet&&PageDLLUpdate.OnApply();
	bRet=bRet&&PageFileListWindow.OnApply();
	bRet=bRet&&PageAssociation.OnApply();
	bRet=bRet&&PageOpenAction.OnApply();

	//UAC̃AVX^gvĂ
	if(m_nAssistRequireCount>0){
		//64bitȂ64bitpɑ点
		if(UtilIsWow64()){
			//LFAssist(64bit)ɏnBINI폜͍sȂB
			//---AVX^g(64bit)̃pX擾
			CPath strExePath(UtilGetModuleDirectoryPath());
			strExePath+=_T("LFAssist64.exe");
			if(strExePath.FileExists()){	//t@C݂Ƃ̂
				strExePath.QuoteSpaces();

				//---s:CreateProcessłUAC`FbNĎsĂ炦Ȃ
				SHELLEXECUTEINFO shei={0};
				shei.fMask=SEE_MASK_FLAG_DDEWAIT;	//uɏI\̂łw肷
				shei.cbSize=sizeof(shei);
				shei.lpFile=strExePath;
				shei.lpParameters=m_strAssistINI;
				shei.nShow=SW_SHOW;
				if(!ShellExecuteEx(&shei)){
					//sG[
					LPVOID lpMsgBuf;
					FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER|FORMAT_MESSAGE_FROM_SYSTEM|FORMAT_MESSAGE_IGNORE_INSERTS,NULL,GetLastError(),MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),(LPTSTR)&lpMsgBuf, 0, NULL);

					CString msg;
					msg.Format(IDS_ERROR_CANNOT_EXECUTE,strExePath,lpMsgBuf);
					LocalFree(lpMsgBuf);

					ErrorMessage(msg);
				}
			}
		}

		//LFAssist(32bit)INI폜v
		WritePrivateProfileString(_T("PostProcess"),_T("DeleteMe"),_T("Please_Delete_Me"),m_strAssistINI);

		//ύXs
		//---AVX^g̃pX擾
		CPath strExePath(UtilGetModuleDirectoryPath());
		strExePath+=_T("LFAssist.exe");
		strExePath.QuoteSpaces();

		//---s:CreateProcessłUAC`FbNĎsĂ炦Ȃ
		SHELLEXECUTEINFO shei={0};
		shei.fMask=SEE_MASK_FLAG_DDEWAIT;	//uɏI\̂łw肷
		shei.cbSize=sizeof(shei);
		shei.lpFile=strExePath;
		shei.lpParameters=m_strAssistINI;
		shei.nShow=SW_SHOW;
		if(!ShellExecuteEx(&shei)){
			//sG[
			LPVOID lpMsgBuf;
			FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER|FORMAT_MESSAGE_FROM_SYSTEM|FORMAT_MESSAGE_IGNORE_INSERTS,NULL,GetLastError(),MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),(LPTSTR)&lpMsgBuf, 0, NULL);

			CString msg;
			msg.Format(IDS_ERROR_CANNOT_EXECUTE,strExePath,lpMsgBuf);
			LocalFree(lpMsgBuf);

			ErrorMessage(msg);
		}else{
			Sleep(100);
			::SHChangeNotify(SHCNE_ASSOCCHANGED,SHCNF_FLUSH,NULL,NULL);	//֘At̕ύXVFɒʒm(ύXĂȂȂȕւ̂)
		}
	}else{
		//e|INI폜
		if(!m_strAssistINI.IsEmpty()){
			::DeleteFile(m_strAssistINI);
		}
	}

	if(bRet)EndDialog(nID);
}

void CConfigDialog::OnCancel(UINT uNotifyCode, int nID, HWND hWndCtl)
{
	EndDialog(nID);
}

LRESULT CConfigDialog::OnTreeSelect(LPNMHDR pnmh)
{
	if(pnmh->hwndFrom==SelectTreeView){
		HTREEITEM hItem=SelectTreeView.GetSelectedItem();
		if(!hItem)return 0;

		HWND hSelectedDialogWnd=(HWND)SelectTreeView.GetItemData(hItem);
		if(NULL!=hSelectedDialogWnd && hSelectedDialogWnd!=hActiveDialogWnd){
			::ShowWindow(hActiveDialogWnd,SW_HIDE);
			::ShowWindow(hSelectedDialogWnd,SW_SHOW);
			ScrollWindow.SetClient(NULL);
			ScrollWindow.SetClient(hSelectedDialogWnd);
			hActiveDialogWnd=hSelectedDialogWnd;
		}
	}
	return 0;
}

void CConfigDialog::OnSize(UINT, CSize&)
{
	SetMsgHandled(false);
	PostMessage(WM_USER_WM_SIZE);
}

LRESULT CConfigDialog::OnUserSize(UINT, WPARAM, LPARAM, BOOL& bHandled)
{
	//vpeBV[g\t邽߂̃XN[Rei̔zuꏊ擾
	CStatic StaticFrame;
	StaticFrame=GetDlgItem(IDC_STATIC_FRAME);
	RECT rect;
	StaticFrame.GetWindowRect(&rect);
	ScreenToClient(&rect);

	//XN[Reiړ
	ScrollWindow.MoveWindow(&rect);
	return 0;
}

//LFAssist.exe̗vJEg𑀍
void CConfigDialog::RequireAssistant()
{
	m_nAssistRequireCount++;
	Button_SetElevationRequiredState(GetDlgItem(IDOK),m_nAssistRequireCount);
}

void CConfigDialog::UnrequireAssistant()
{
	ASSERT(m_nAssistRequireCount>0);
	if(m_nAssistRequireCount>0){
		m_nAssistRequireCount--;
		Button_SetElevationRequiredState(GetDlgItem(IDOK),m_nAssistRequireCount);
	}
}
