#include "common.h"
#include "dirtree.h"
#include "../util.h"

CDirectoryTree::CDirectoryTree()
{
	Clear();
}

CDirectoryTree::~CDirectoryTree()
{
	Clear();
}

void CDirectoryTree::Clear()
{
	m_bPathSafe=true;
	m_lpParent=NULL;
	m_strFullPath.Empty();
	m_strExt.Empty();
	m_strMethod.Empty();
	m_bDir=false;
	m_strNodeName.Empty();
	m_Attribute=-1;
	m_wRatio=-1;
	m_dwCRC=-1;
	m_OriginalSize.LowPart=-1;
	m_OriginalSize.HighPart=-1;

	m_CompressedSize.LowPart=-1;
	m_CompressedSize.HighPart=-1;

	m_FileTime.dwLowDateTime=-1;
	m_FileTime.dwHighDateTime=-1;

	std::vector<CDirectoryTree*>::iterator ite=m_NodeArrayOriginal.begin();
	const std::vector<CDirectoryTree*>::iterator end=m_NodeArrayOriginal.end();
	for(;ite!=end;ite++){
		delete (*ite);
	}
	m_NodeArray.clear();
	m_NodeArrayOriginal.clear();
	m_NonFileNodeMap.clear();
	m_bFindMode=false;
}


bool CDirectoryTree::AddItem(CDTDataContainer &dtdc,const bool bIgnoreMeaninglessPath,FILELISTMODE FileListMode)
{
	//Kw\͂Ȃꍇ́Aʃ\bhŏ
	if(FileListMode!=FILELIST_TREE)return AddItem_Flat(dtdc,bIgnoreMeaninglessPath,FileListMode==FILELIST_FLAT_FILESONLY);

	ASSERT(!dtdc.pathList.empty());
	if(dtdc.pathList.empty()){
		return false;
	}

	//擪̃pXvfo
	stdString strPath(*dtdc.pathList.begin());
	dtdc.pathList.pop_front();
	if(bIgnoreMeaninglessPath){
		while(true){
			//---ȃpXǂ`FbN
			const UINT Length=strPath.length();
			//2ȏ̃pX͗LłƌȂ
			if(Length>=2){
				break;
			}
			if(0==Length||strPath==_T(".")){
				//ȃpXȂ疳āA̗vfĂ
				if(dtdc.pathList.empty()){
					//pX̗vfȂȂ̂ŕԂ
					return true;
				}
				strPath=*dtdc.pathList.begin();
				dtdc.pathList.pop_front();
			}else{
				break;
			}
		}
	}

	//t@Cłƕ̂Ƃ̓m[h[fBNg]̔rsȂ
	std::hash_map<stdString,CDirectoryTree*>::iterator ite=m_NonFileNodeMap.find(strPath);
	const std::hash_map<stdString,CDirectoryTree*>::iterator end=m_NonFileNodeMap.end();
	//----------
	// pXr
	//----------
	if(ite!=end){	//̃tH_ɖOv̂
		if(dtdc.pathList.empty()){	//ꂪpX̍Ō̗vf
			//ɓo^悤ƂĂ̂̓fBNg
			//ɓfBNgo^Ă̂ŕԂ

			//---ǉ̃fBNgĂȂ炻ݒ
			//tpX
			if((*ite).second->m_strFullPath.IsEmpty()){
				(*ite).second->m_strFullPath=dtdc.strFullPath;
			}
			//
			if(-1==(*ite).second->m_Attribute){
				(*ite).second->m_Attribute=dtdc.Attribute;
			}
			return true;
		}else{
			//Tuɒǉ
			return (*ite).second->AddItem(dtdc,bIgnoreMeaninglessPath,FileListMode);
		}
	}else{
		//ɏ̂͊̃m[h(fBNg)ɂ͈v݂̂Ȃꍇ
		//m[h₷
		CDirectoryTree* dt=new CDirectoryTree;

		if(dtdc.bEndWithSeparator||!dtdc.pathList.empty()){	//炩ɃfBNgłꍇ
			//Path'/''\\'ŏIĂA͂ꂪpX̍Ō̗vfł͂Ȃ
			dt->m_bDir=true;
		}
		dt->m_strNodeName=strPath.c_str();

		//em[hݒ
		dt->m_lpParent=this;

		if(dtdc.pathList.empty()){	//̃m[h͎̒ɂ
			dt->m_strFullPath=dtdc.strFullPath;
			dt->m_Attribute=dtdc.Attribute;
			dt->m_strExt=PathFindExtension(dtdc.strFullPath);
			dt->m_OriginalSize=dtdc.OriginalSize;
			dt->m_CompressedSize=dtdc.CompressedSize;
			dt->m_FileTime=dtdc.FileTime;
			dt->m_strMethod=dtdc.strMethod;
			dt->m_wRatio=dtdc.wRatio;
			dt->m_dwCRC=dtdc.dwCRC;
			m_NodeArrayOriginal.push_back(dt);	//[̃m[h

			if(-1==dt->m_Attribute||(dt->m_Attribute&FA_DIREC)){	//t@CXgɓo^
				m_NonFileNodeMap.insert(std::pair<stdString,CDirectoryTree*>(strPath,dt));
			}
			return true;
		}else{
			//̃m[h͂ɐ[Kwɒǉ
			if(!dt->AddItem(dtdc,bIgnoreMeaninglessPath,FileListMode))return false;
			m_NodeArrayOriginal.push_back(dt);
			if(-1==dt->m_Attribute||(dt->m_Attribute&FA_DIREC)){	//t@CXgɓo^
				m_NonFileNodeMap.insert(std::pair<stdString,CDirectoryTree*>(strPath,dt));
			}
			return true;
		}
	}
}

//Kw\͂ȂAddItem
bool CDirectoryTree::AddItem_Flat(CDTDataContainer &dtdc,const bool bIgnoreMeaninglessPath,const bool bFilesOnly)
{
	ASSERT(!dtdc.pathList.empty());
	if(dtdc.pathList.empty()){
		return false;
	}

	if(bFilesOnly){	//t@CłȂΒǉȂ
		if((dtdc.Attribute!=-1)
			&&(dtdc.Attribute&FA_DIREC))return true;
	}

	//qm[h₷
	CDirectoryTree* dt=new CDirectoryTree;

	//Ō̃pXvfo
	stdString strPath(dtdc.pathList.back());

	dt->m_strNodeName=strPath.c_str();

	//fBNgɂSeparator
	if(dtdc.bEndWithSeparator){
		dt->m_strNodeName+=dtdc.strFullPath[dtdc.strFullPath.GetLength()-1];
	}

	//em[hݒ
	dt->m_lpParent=this;

	//̃m[h͎̒ɂ
	dt->m_strFullPath=dtdc.strFullPath;
	dt->m_Attribute=dtdc.Attribute;
	dt->m_strExt=PathFindExtension(dtdc.strFullPath);
	dt->m_OriginalSize=dtdc.OriginalSize;
	dt->m_CompressedSize=dtdc.CompressedSize;
	dt->m_FileTime=dtdc.FileTime;
	dt->m_strMethod=dtdc.strMethod;
	dt->m_wRatio=dtdc.wRatio;
	dt->m_dwCRC=dtdc.dwCRC;
	m_NodeArrayOriginal.push_back(dt);	//m[hǉ
	return true;
}

//w肵O̎qm[h̃|C^Ԃ
CDirectoryTree* CDirectoryTree::GetChild(LPCTSTR ChildName)
{
	TRACE(_T(":::%s==>%s\n"),GetName(),ChildName);
	std::vector<CDirectoryTree*>::iterator ite_node=m_NodeArray.begin();
	const std::vector<CDirectoryTree*>::iterator end=m_NodeArray.end();
	for(;ite_node!=end;ite_node++){
		if(ChildName==(*ite_node)->m_strNodeName){
			return (*ite_node);
		}
	}
	return NULL;
}

void CDirectoryTree::PostProcess(bool bUnicode)
{
	m_NodeArray=m_NodeArrayOriginal;
	//
	if(-1==m_Attribute){	//܂ĂȂꍇ
		if(!m_NodeArray.empty()||m_bDir){
			//ȉ̏̂ꂩɍv΃fBNg
			//Em[hɃpX؂蕶tĂ(bDir)
			//Eqm[hłȂ
			m_Attribute=FA_DIREC;
			m_bDir=true;
		}
		else{
			m_Attribute=FA_UNKNOWN;
		}
	}
	else{
		if(!m_NodeArray.empty()||m_bDir){
			m_Attribute|=FA_DIREC;
			m_bDir=true;
		}
	}
	if(m_Attribute&FA_DIREC){
		//tH_ɂ͊gq͂Ȃ
		m_strExt=FOLDER_EXTENSION_STRING;
	}
	else{
		m_strExt.MakeLower();
	}

	//댯
	if(bUnicode){
		m_bPathSafe=UtilIsSafeUnicode(m_strFullPath);
	}

	//qm[hɂKp
	std::vector<CDirectoryTree*>::iterator ite_node=m_NodeArray.begin();
	const std::vector<CDirectoryTree*>::iterator end=m_NodeArray.end();

	if(m_Attribute&FA_DIREC){
		m_OriginalSize.QuadPart=0;
		m_CompressedSize.QuadPart=0;
	}

	for(;ite_node!=end;ite_node++){
		(*ite_node)->PostProcess(bUnicode);

		if(m_Attribute&FA_DIREC){
			//---kOTCY
			if(m_OriginalSize.QuadPart>=0){	//t@CTCY擾ɎsĂȂ
				LARGE_INTEGER TempSize=(*ite_node)->GetOriginalSize();
				if(TempSize.QuadPart>=0){
					m_OriginalSize.QuadPart+=TempSize.QuadPart;
				}
				else{
					m_OriginalSize.LowPart=-1;
					m_OriginalSize.HighPart=-1;
				}
			}
			//---kTCY
			if(m_CompressedSize.QuadPart>=0){	//t@CTCY擾ɎsĂȂ
				LARGE_INTEGER TempSize=(*ite_node)->GetCompressedSize();
				if(TempSize.QuadPart>=0){
					m_CompressedSize.QuadPart+=TempSize.QuadPart;
				}
				else{
					m_CompressedSize.LowPart=-1;
					m_CompressedSize.HighPart=-1;
				}
			}
		}
	}
}


//r֐IuWFNg
struct COMP{
	FILEINFO_TYPE Type;
	bool operator()(CDirectoryTree* x, CDirectoryTree* y)const{
		switch(Type){
		case FILEINFO_FILENAME:
			//fBNgɗ悤ɂ
			if(x->m_bDir){
				if(!y->m_bDir){
					return true;
				}
			}
			else if(y->m_bDir){
				return false;
			}
			return (_tcsicmp(x->m_strNodeName , y->m_strNodeName)<0);
		case FILEINFO_FULLPATH:
			return (_tcsicmp(x->m_strFullPath , y->m_strFullPath)<0);
		case FILEINFO_ORIGINALSIZE:
			return (x->m_OriginalSize.QuadPart < y->m_OriginalSize.QuadPart);
		case FILEINFO_TYPENAME:
			return (_tcsicmp(x->m_strExt , y->m_strExt)<0);
		case FILEINFO_FILETIME:
			return (CompareFileTime(&x->m_FileTime , &y->m_FileTime)<0);
		case FILEINFO_ATTRIBUTE:
			return (x->m_Attribute < y->m_Attribute);
		case FILEINFO_COMPRESSEDSIZE://kt@CTCY
			return (x->m_CompressedSize.QuadPart < y->m_CompressedSize.QuadPart);
		case FILEINFO_METHOD:			//k\bh
			return (_tcsicmp(x->m_strMethod , y->m_strMethod)<0);
		case FILEINFO_RATIO:			//k
			return (x->m_wRatio < y->m_wRatio);
		case FILEINFO_CRC:			//CRC
			return (x->m_dwCRC < y->m_dwCRC);
		}
		return false;
	}
};


//\[g
void CDirectoryTree::Sort(FILEINFO_TYPE Type)
{
	if(m_bFindMode)return;
	if(Type<FILEINFO_INVALID||Type>=FILEINFO_MAX_NUM)return;

	m_NodeArray=m_NodeArrayOriginal;
	if(FILEINFO_INVALID==Type){		//\[g
		return;
	}
	COMP Comp;
	Comp.Type=Type;
	std::sort(m_NodeArray.begin(),m_NodeArray.end(),Comp);
}

bool CDirectoryTree::EnumFiles(std::list<CString> &FileList)
{
	if(m_Attribute&FA_DIREC){
		std::vector<CDirectoryTree*>::iterator ite=m_NodeArrayOriginal.begin();
		std::vector<CDirectoryTree*>::iterator end=m_NodeArrayOriginal.end();
		for(;ite!=end;ite++){
			(*ite)->EnumFiles(FileList);
		}
	}
	if(!m_strFullPath.IsEmpty()){
		FileList.push_back(m_strFullPath);
	}
	return true;
}

void CDirectoryTree::GetDirPathRelative(CDirectoryTree *lpDir,const CDirectoryTree *lpBase,CString &strPath)
{
	//Ŗʓ|ȂƂĂ̂́A
	//lpBasetpXĂȂ(=LhaForgezIɍotH_)Ƃ邩B
	strPath.Empty();

	CDirectoryTree *dt=lpDir;
	for(;(NULL!=dt)&&(lpBase!=dt);dt=dt->GetParent()){
		CString Buffer=dt->GetName();

		Buffer.Replace(_T('/'),_T('\\'));
		if(-1!=Buffer.Find(_T('\\'))){
			//fBNgm[h̖OɃpX؂蕶̂́AKw\𖳎ꗗ̎̂݁B
			//̂Ƃ́ApX؂S΂KvB
			PathStripPath(Buffer.GetBuffer(_MAX_PATH+1));	//ԍŌ̕cāApXJbg
			Buffer.ReleaseBuffer();
			Buffer.Remove(_T('\\'));	//pX؂蕶U폜
		}
		Buffer+=_T('\\');
		strPath.Insert(0,Buffer);
	}
	// o̓pX̏C
	UtilModifyPath(strPath);
}

void CDirectoryTree::_FindItem(LPCTSTR lpszMask,bool bMatchPath,std::vector<CDirectoryTree*> &retArray)
{
	UINT i;
	for(i=0;i<m_NodeArrayOriginal.size();i++){
		CDirectoryTree *dt=m_NodeArrayOriginal[i];
		ASSERT(dt);
		CString strKey;
		if(bMatchPath){	//pXv
			strKey=dt->m_strFullPath;
			strKey.Replace(_T("/"),_T("\\"));
		}else{
			strKey=dt->m_strNodeName;
		}
		if(PathMatchSpec(strKey,lpszMask)){
			retArray.push_back(dt);
		}
		if(dt->m_bDir){	//fBNg͍ċA
			dt->_FindItem(lpszMask,bMatchPath,retArray);
		}
	}
}

void CDirectoryTree::FindItem(LPCTSTR lpszMask,CDirectoryTree *lpTop)
{
	ASSERT(!m_lpParent);	//ȕւ̂߁Ȃ삪̂̓[gm[hɑ΂Ă̂
	ASSERT(lpTop);
	if(!lpTop)return;
	m_NodeArray.clear();

	CString strMask(lpszMask);
	strMask.Replace(_T("/"),_T("\\"));
	bool bMatchPath=(-1!=strMask.Find(_T('\\')));

	//*?tĂȂꍇ*ɒǉ
	if(-1==strMask.FindOneOf(_T("*?"))){
		strMask.Insert(0,_T("*"));
		strMask+=_T("*");
	}

	lpTop->_FindItem(strMask,bMatchPath,m_NodeArray);

	m_bFindMode=true;
}
