#include "common.h"
#include "LogListDialog.h"
#include "../util.h"

//OZbg
void CLogListDialog::SetLogArray(const std::vector<ARCLOG> &rLog)
{
	m_LogArray=rLog;

	//ׂOKǂ`FbN
	UINT size=m_LogArray.size();
	m_bAllOK=true;
	for(UINT i=0;i<size;i++){
		if(m_LogArray[i].Result!=EXTRACT_OK&&m_LogArray[i].Result!=TEST_OK){
			m_bAllOK=false;
			//break;
		}
		//̒u
		m_LogArray[i].strMsg.Replace(_T("\n"),_T("\r\n"));
		m_LogArray[i].strMsg.Replace(_T("\r\r\n"),_T("\r\n"));
	}
}

LRESULT CLogListDialog::OnInitDialog(HWND hWnd, LPARAM lParam)
{
	if(m_LogArray.empty()){
		m_bAllOK=true;
	}

	CenterWindow();

	//---_CAȌ
	// 傫ACRݒ
	HICON hIcon = AtlLoadIconImage(IDI_APP, LR_DEFAULTCOLOR,::GetSystemMetrics(SM_CXICON),::GetSystemMetrics(SM_CYICON));
	SetIcon(hIcon, TRUE);
	// ACRݒ
	HICON hIconSmall = AtlLoadIconImage(IDI_APP, LR_DEFAULTCOLOR,::GetSystemMetrics(SM_CXSMICON), ::GetSystemMetrics(SM_CYSMICON));
	SetIcon(hIconSmall, FALSE);

	//_CAOLvVݒ
	SetWindowText(CString(MAKEINTRESOURCE(IDS_LOGINFO_OPERATION_TESTARCHIVE))+(m_bAllOK?_T("[All Clear]"):_T("[NG]")));

	//[hݒ
	CStatic StaticInfo=GetDlgItem(IDC_STATIC_LOGINFO);
	StaticInfo.SetWindowText(CString(MAKEINTRESOURCE(IDS_LOGINFO_OPERATION_TESTARCHIVE)));

	//------------------------
	//---GfBbg̏
	m_MsgEdit=GetDlgItem(IDC_EDIT_LOGINFO_MSG);
	m_PathEdit=GetDlgItem(IDC_EDIT_LOGINFO_FILE);


	//---Xgr[̏
	m_ItemListView=GetDlgItem(IDC_LIST_LOGINFO_ITEMS);
	//X^Cݒ
	m_ItemListView.SetExtendedListViewStyle(/*LVS_EX_INFOTIP | */LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES|LVS_EX_HEADERDRAGDROP);
	//---Xgr[ɃJǉ
	//t@C
	m_ItemListView.InsertColumn(0, CString(MAKEINTRESOURCE(IDS_FILELIST_COLUMN_FILENAME)), LVCFMT_LEFT, 160,-1);
	//(OK/NG)
	CRect rc;
	m_ItemListView.GetClientRect(rc);
	m_ItemListView.InsertColumn(1, CString(MAKEINTRESOURCE(IDS_LOGINFO_RESULT)), LVCFMT_LEFT, rc.Width()-160-15,-1);

	//|[g[hɐݒ
	DWORD Style=m_ItemListView.GetWindowLong(GWL_STYLE);
	Style&=~(LVS_ICON|LVS_REPORT|LVS_SMALLICON|LVS_LIST);
	m_ItemListView.SetWindowLong(GWL_STYLE,Style|LVS_REPORT);


	//ACeݒ
	m_ItemListView.SetItemCount(m_LogArray.size());
	if(!m_LogArray.empty()){
		m_ItemListView.SetItemState(0,LVNI_SELECTED,LVNI_SELECTED);
	}

	//---Xgr[ɃtH[JX
	m_ItemListView.SetFocus();

	//---_CAOTCY
	DlgResize_Init(true, true, WS_THICKFRAME | WS_CLIPCHILDREN);
	//---EBhEANeBuɂ
	UtilSetAbsoluteForegroundWindow(m_hWnd);

	return TRUE;
}



//zXgr[̃ACe擾ɔ
LRESULT CLogListDialog::OnGetDispInfo(LPNMHDR pnmh)
{
	LV_DISPINFO* pstLVDInfo=(LV_DISPINFO*)pnmh;

	//Y`FbN
	if(pstLVDInfo->item.iItem<0||(unsigned int)pstLVDInfo->item.iItem>=m_LogArray.size())return 0;

	ARCLOG &LogInfo=m_LogArray[pstLVDInfo->item.iItem];

	switch(pstLVDInfo->item.iSubItem){
	case 0:	//t@C
		if(pstLVDInfo->item.mask & LVIF_TEXT){
			_tcsncpy_s(pstLVDInfo->item.pszText,pstLVDInfo->item.cchTextMax, LogInfo.strFile,pstLVDInfo->item.cchTextMax);
			PathStripPath(pstLVDInfo->item.pszText);
		}
		break;
	case 1:	//(OK/NG)
		if(pstLVDInfo->item.mask & LVIF_TEXT){
			WORD wCaption=-1;
			switch(LogInfo.Result){
			case EXTRACT_OK:
				wCaption=IDS_LOGINFO_RESULT_OK;
				break;
			case EXTRACT_NG:
				wCaption=IDS_LOGINFO_RESULT_NG;
				break;
			case TEST_OK:
				wCaption=IDS_LOGINFO_RESULT_OK;
				break;
			case TEST_NG:
				wCaption=IDS_LOGINFO_RESULT_NG;
				break;
			case TEST_NOTIMPL:
				wCaption=IDS_LOGINFO_RESULT_NOTIMPL;
				break;
			case EXTRACT_NOTARCHIVE:	//FALLTHROUGH
			case TEST_NOTARCHIVE:
				wCaption=IDS_LOGINFO_RESULT_NOTARCHIVE;
				break;
			case TEST_ERROR:
				wCaption=IDS_LOGINFO_RESULT_ERROR;
				break;
			default:
				ASSERT(!"This code cannot be run");
				return 0;
			}
			_tcsncpy_s(pstLVDInfo->item.pszText,pstLVDInfo->item.cchTextMax, CString(MAKEINTRESOURCE(wCaption)),pstLVDInfo->item.cchTextMax);
		}
		break;
	}
	return 0;
}


//JX^h[
DWORD CLogListDialog::OnPrePaint(int nID, LPNMCUSTOMDRAW lpnmcd)
{
	if(lpnmcd->hdr.idFrom==IDC_LIST_LOGINFO_ITEMS)return CDRF_NOTIFYITEMDRAW;
	return CDRF_DODEFAULT;
}

DWORD CLogListDialog::OnItemPrePaint(int nID, LPNMCUSTOMDRAW lpnmcd)
{
	if(lpnmcd->hdr.idFrom==IDC_LIST_LOGINFO_ITEMS){
		//ʂɂĐFς
		LPNMLVCUSTOMDRAW lpnmlv = (LPNMLVCUSTOMDRAW)lpnmcd;
		switch(m_LogArray[lpnmcd->dwItemSpec].Result){
		case EXTRACT_OK:	//FALLTHROUGH
		case TEST_OK:
			return CDRF_DODEFAULT;
		case EXTRACT_NG:	//FALLTHROUGH
		case TEST_NG:
			lpnmlv->clrText = RGB(0, 0, 0);
			lpnmlv->clrTextBk = RGB(255, 153, 153);
			break;
		case TEST_NOTIMPL:
			lpnmlv->clrText = RGB(0, 0, 0);
			lpnmlv->clrTextBk = RGB(204, 204, 255);
			break;
		case EXTRACT_NOTARCHIVE:	//FALLTHROUGH
		case TEST_NOTARCHIVE:
			lpnmlv->clrText = RGB(0, 0, 0);
			lpnmlv->clrTextBk = RGB(240, 240, 0);
			break;
		case TEST_ERROR:
			lpnmlv->clrText = RGB(0, 0, 0);
			lpnmlv->clrTextBk = RGB(255, 51, 51);
			break;
		default:
			ASSERT(!"This code cannot be run");
		}
		return CDRF_NOTIFYITEMDRAW;
	}
	return CDRF_DODEFAULT;
}

LRESULT CLogListDialog::OnItemChanged(LPNMHDR pnmh)
{
	if(pnmh->hwndFrom!=m_ItemListView){
		return FALSE;
	}

	int iItem=m_ItemListView.GetNextItem(-1,LVNI_ALL|LVNI_SELECTED);
	//iItem==-1 if not found
	if(iItem<0||(unsigned)iItem>=m_LogArray.size())return FALSE;
	m_MsgEdit.SetWindowText(m_LogArray[iItem].strMsg);
	m_PathEdit.SetWindowText(m_LogArray[iItem].strFile);
	return TRUE;
}

//Rg[̐F:ǂݎpGfBbg
HBRUSH CLogListDialog::OnCtrlColorEdit(HDC,HWND hWnd)
{
	if(hWnd==m_MsgEdit||hWnd==m_PathEdit){
		return (HBRUSH)GetStockObject(WHITE_BRUSH);
	}
	else return (HBRUSH)CDialogImpl<CLogListDialog>::DefWindowProc();
}


//r֐IuWFNg
struct COMP{
	int nCol;	//rɎg
	COMP(int n):nCol(n){}
	bool operator()(const ARCLOG& x, const ARCLOG& y)const{
		switch(nCol){
		case 0:	//t@C
			return (_tcsicmp(x.strFile, y.strFile)<0);
		case 1:	//Xe[^X
			return (x.Result< y.Result);
		default:
			ASSERT(!"This code cannot be run");
			return false;
		}
	}
};


//\[g
LRESULT CLogListDialog::OnSortItem(LPNMHDR pnmh)
{
	//Xgr[ɂȂ
	if(pnmh->hwndFrom!=m_ItemListView){
		return 0;
	}

	//1ȉȂ\[g͕KvȂ
	if(m_LogArray.size()<=1){
		return 0;
	}

	LPNMLISTVIEW lpNMLV=(LPNMLISTVIEW)pnmh;
	int nCol=lpNMLV->iSubItem;
	if(nCol==m_nSortColumn){
		//t\[g
		m_bSortDescending = !m_bSortDescending;
		std::reverse(m_LogArray.begin(),m_LogArray.end());	//t
		m_ItemListView.Invalidate();
		return 0;
	}

	switch(nCol){
	case 0:	//t@C
	case 1:	//Xe[^X
		std::sort(m_LogArray.begin(),m_LogArray.end(),COMP(nCol));
		break;
	default:
		ASSERT(!"This code cannot be run");
		return 0;
	}

	m_nSortColumn=nCol;
	m_ItemListView.Invalidate();
	return 0;
}
