#include "common.h"
#if defined(__LFASSIST__)
 #include "./LFAssist/resource.h"
#else	//LhaForge{
 #include "resource.h"
 #include "ConfigCode/config.h"
#endif
#include "util.h"


#if !defined(_UNICODE)&&!defined(UNICODE)
 #include <imagehlp.h> //MakeSureDirectoryPathExists()
#endif

void UtilDebugTrace(LPCTSTR pszFormat, ...)
{
	va_list	args;

	va_start(args, pszFormat);
	CString str;
	str.FormatV(pszFormat,args);
	va_end(args);

	OutputDebugString(str);
}

//G[bZ[W\
int ErrorMessage(LPCTSTR msg)
{
	TRACE(_T("ErrorMessage:")),TRACE(msg),TRACE(_T("\n"));
	return MessageBox(NULL,msg,UtilGetMessageCaption(),MB_OK|MB_ICONSTOP);
}

//bZ[WLvV擾
LPCTSTR UtilGetMessageCaption()
{
	const static CString strCaption(MAKEINTRESOURCE(IDS_MESSAGE_CAPTION));
	return strCaption;
}

bool UtilIsSBSymbolorNumber(LPCTSTR String,int Index)
{
	static const TCHAR Table[]=_T("0123456789./*-+{}[]@`:;!\"#$%&\'()_><=~^|,\\");
	static const size_t Length=_tcslen(Table);

#if !defined(_UNICODE)&&!defined(UNICODE)
	if(_MBC_SINGLE!=_mbsbtype((const unsigned char*)String,Index))return false;
#endif
	const TCHAR c=String[Index];
	for(UINT i=0;i<Length;i++){
		if(Table[i]==c)return true;
	}
	return false;
}


bool UtilGetTemporaryFileName(LPTSTR fname,LPCTSTR prefix)
{
	TCHAR TempDirPath[_MAX_PATH+1];
	FILL_ZERO(TempDirPath);
	GetTempPath(_MAX_PATH,TempDirPath);
	if(!GetTempFileName(TempDirPath,prefix,0,fname))
	{
		//ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_TEMPORARY_FILE_CREATE)));
		return false;
	}
	return true;
}

bool UtilGetTemporaryFileNameA(LPSTR fname,LPCSTR prefix)
{
	char TempDirPath[_MAX_PATH+1];
	FILL_ZERO(TempDirPath);
	GetTempPathA(_MAX_PATH,TempDirPath);
	if(!GetTempFileNameA(TempDirPath,prefix,0,fname))
	{
		//ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_TEMPORARY_FILE_CREATE)));
		return false;
	}
	return true;
}

bool UtilDeletePath(LPCTSTR PathName)
{
	if(PathIsDirectory(PathName)){//fBNg
		//t@C̑Wɖ߂
		SetFileAttributes(PathName,FILE_ATTRIBUTE_NORMAL);
		if(RemoveDirectory(PathName))return true;
	}
	else if(PathFileExists(PathName)){//t@C
		//t@C̑Wɖ߂
		SetFileAttributes(PathName,FILE_ATTRIBUTE_NORMAL);
		if(DeleteFile(PathName))return true;
	}
	return false;
}

//bDeleteParent=truêƂAPathg폜
//bDeleteParent=falsêƂ́APath̒g폜
bool UtilDeleteDir(LPCTSTR Path,bool bDeleteParent)
{
	WIN32_FIND_DATA lp;

	TCHAR FindParam[_MAX_PATH+1];
	FILL_ZERO(FindParam);
	_tcsncpy_s(FindParam,Path,_MAX_PATH);
	PathAppend(FindParam,_T("*"));
	HANDLE h=FindFirstFile(FindParam,&lp);

	bool bRet=true;

	do{
		if((lp.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)&& 0!=_tcscmp(lp.cFileName,_T("..")) && 0!=_tcscmp(lp.cFileName,_T(".")))
		{
			CString SubPath=Path;
			SubPath+=_T("\\");
			SubPath+=lp.cFileName;

			bRet=bRet&&UtilDeleteDir(SubPath,true);
		}
		if((lp.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)!=FILE_ATTRIBUTE_DIRECTORY)
		{
			// lp.cFileNameŃt@C
			TCHAR FileName[_MAX_PATH+1];
			FILL_ZERO(FileName);
			_tcsncpy_s(FileName,Path,_MAX_PATH);
			PathAppend(FileName,lp.cFileName);

			bRet=bRet&&UtilDeletePath(FileName);
		}
	}while(FindNextFile(h,&lp));

	FindClose(h);
	if(bDeleteParent){
		bRet=bRet&&UtilDeletePath(Path);
	}

	return bRet;
}

bool UtilIsWindowsNT()
{
	OSVERSIONINFO osi;
	FILL_ZERO(osi);
	osi.dwOSVersionInfoSize=sizeof(osi);
	GetVersionEx(&osi);
	return (VER_PLATFORM_WIN32_NT==osi.dwPlatformId);
}

#ifndef __LFASSIST__
//=======================================================
//From http://www.athomejp.com/goldfish/api/shortcut.asp
//=======================================================
HRESULT UtilCreateShortcut(LPCTSTR lpszPathLink,LPCTSTR lpszPathTarget,LPCTSTR lpszArgs,LPCTSTR lpszIconPath,int iIcon,LPCTSTR lpszDescription)
{
	HRESULT hRes;
	IShellLink* psl =NULL;

//	// COMC^[tFCX
//	CoInitialize(nULL);

	// IShellLink C^[tFCX擾
	hRes = CoCreateInstance(
		CLSID_ShellLink,NULL,
		CLSCTX_INPROC_SERVER,
		IID_IShellLink,
		(LPVOID *)&psl);

	if(FAILED(hRes)){
		//s
		ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_CREATE_SHORTCUT)));
		return hRes;
	}

	IPersistFile* ppf=NULL;
	// LinkIuWFNg̃pXݒ(Ƃ΁AC:\Windows\notepad.exeȂ)
	psl->SetPath(lpszPathTarget);
	//ݒ
	psl->SetArguments(lpszArgs);
	//ACRݒ
	psl->SetIconLocation(lpszIconPath,iIcon);
	//ݒ
	psl->SetDescription(lpszDescription);
	// IPersistFileC^[tFCX擾A
	// LinkpXt@CۑB
	// ́AIShellLink̒
	// fBXN֘AIuWFNg
	// 擾ĂƎvĂB
	hRes =psl->QueryInterface( IID_IPersistFile,(void**)&ppf);
	if(FAILED(hRes)){
		//ppf̎擾Ɏs
		ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_CREATE_SHORTCUT)));
		psl->Release();
		return hRes;
	}

#if defined(_UNICODE)||defined(UNICODE)
	hRes = ppf->Save(lpszPathLink, TRUE);
#else
	WCHAR wsz[_MAX_PATH+1];

	// pXChɕϊ
	// ́Å֐Save
	// Cḧ̂

	MultiByteToWideChar(CP_ACP, 0,lpszPathLink, -1,wsz, _MAX_PATH);
	// fBXNɕۑ
	hRes = ppf->Save(wsz, TRUE);
#endif
	ppf->Release();
	psl->Release();
	return hRes;
}
#endif// __LFASSIST__



//ǂݎ茳t@Cݐt@Cseek̂ӏɃRs[ď
//߂l̓G[ȂȂ0,ǂݎG[1,݃G[-1
int UtilAppendFile(HANDLE hWriteTo,HANDLE hReadFrom)
{
	//16KBRs[
	DWORD dwRead=0,dwWrite=0;
	std::vector<BYTE> Buffer(16*1024);
	for(;;){
		if(!ReadFile(hReadFrom,&Buffer.at(0),16*1024,&dwRead,NULL)){
			return 1;
		}
		if(0==dwRead){
			break;
		}
		if(!WriteFile(hWriteTo,&Buffer.at(0),dwRead,&dwWrite,NULL)){
			return -1;
		}
		if(dwRead!=dwWrite){
			return -1;
		}
	}
	return 0;
}

void UtilModifyPath(CString &strPath)
{
	// pX̏C
	strPath.Replace(_T("/"),_T("\\"));	//pX؂蕶

	int Ret=0;
	do{
		Ret=strPath.Replace(_T("\\\\"),_T("\\"));	//\\\ɒuĂ
	}while(Ret!=0);
	strPath.Replace(_T("..\\"),_T("__\\"));	//΃pXw..__ɒu
	strPath.Replace(_T(":"),_T("__"));	//hCuu(C:C__)
}

BOOL UtilMoveFileToRecycleBin(LPCTSTR lpFileName)
{
	ASSERT(lpFileName);
	if(!lpFileName)return false;
	const UINT len=_tcslen(lpFileName);
	std::vector<TCHAR> Buffer(len+2);
	_tcsncpy_s(&Buffer[0],len+1,lpFileName,len+1);
	Buffer.back()=_T('\0');

	SHFILEOPSTRUCT shfo={0};
	shfo.wFunc=FO_DELETE;	//폜
	shfo.pFrom=&Buffer[0];//t@C̃Xg\0\0ŏIKvL
	shfo.fFlags=FOF_SILENT/*i󋵂\Ȃ*/|FOF_ALLOWUNDO/*UNDOt;ݔ*/|FOF_NOCONFIRMATION/*mF_CAO\Ȃ*/;
	return SHFileOperation(&shfo);
}

BOOL UtilMoveFileToRecycleBin(const std::list<CString> &fileList)
{
	ASSERT(!fileList.empty());
	if(fileList.empty())return false;

	//쐬
	CString Param;
	for(std::list<CString>::const_iterator ite=fileList.begin();ite!=fileList.end();++ite){
		Param+=*ite;
		Param+=_T('|');
	}
	Param+=_T('|');
	std::vector<TCHAR> Buffer(Param.GetLength()+1);

	UtilMakeFilterString(Param,&Buffer[0],Buffer.size());

	SHFILEOPSTRUCT shfo={0};
	shfo.wFunc=FO_DELETE;	//폜
	shfo.pFrom=&Buffer[0];//t@C̃Xg\0\0ŏIKvL
	shfo.fFlags=FOF_SILENT/*i󋵂\Ȃ*/|FOF_ALLOWUNDO/*UNDOt;ݔ*/|FOF_NOCONFIRMATION/*mF_CAO\Ȃ*/;
	return SHFileOperation(&shfo);
}

#ifndef __LFASSIST__
void UtilAskAndCheckUpdate(CConfigManager &Config)
{
	if(difftime(time(NULL),Config.Update.LastTime)<Config.Update.Interval*60*60*24){
		return;
	}
/*	int nRet;
	//---TaskDialogĂ݂āA܂sȂMessageBoxőp
	CTaskDialog taskDlg;
	taskDlg.SetWindowTitle(UtilGetMessageCaption());	//^Cg
	taskDlg.SetMainInstructionText(IDS_ASK_UPDATE_DLL_MAIN);	//啶
	taskDlg.SetContentText(IDS_ASK_UPDATE_DLL_SUB);				//⑫
	taskDlg.SetFooterText(IDS_ASK_UPDATE_DLL_HINT);				//qg

	//{^
	TASKDIALOG_BUTTON buttonArray[]={{IDYES,_T("OK")},{IDNO,_T("No")}};
	taskDlg.SetButtons(buttonArray,COUNTOF(buttonArray));
	taskDlg.SetButtonElevationRequiredState(IDYES,TRUE);	//V[hACRZbg

	//\
	nRet=taskDlg.DoModal();
	if(-1==nRet){
		//TaskDialogs
		nRet=MessageBox(NULL,CString(MAKEINTRESOURCE(IDS_ASK_UPDATE_DLL)),UtilGetMessageCaption(),MB_YESNO|MB_ICONQUESTION);
	}*/
	if(IDYES!=MessageBox(NULL,CString(MAKEINTRESOURCE(IDS_ASK_UPDATE_DLL)),UtilGetMessageCaption(),MB_YESNO|MB_ICONQUESTION)){
		//Abvf[gȂȂXV㏑
		//CaldixINIt@C
		/*LPCTSTR CaldixIniPath=Config.GetCaldixIniPath();
		CString Buffer;
		Buffer.Format(_T("%ld"),time(NULL));
		WritePrivateProfileString(_T("Update"),_T("LastTime"),Buffer,CaldixIniPath);*/
		Config.WriteUpdateTime();
		return;
	}
	//------------------------
	// LhaForge{̂̃pX擾
	//------------------------
	TCHAR ExePath[_MAX_PATH+1];
	FILL_ZERO(ExePath);
	GetModuleFileName(GetModuleHandle(NULL), ExePath, _MAX_PATH);

	PathRemoveFileSpec(ExePath);
	PathAppend(ExePath,CString(MAKEINTRESOURCE(IDS_CALDIX_EXE_NAME)));
	if(32>=(int)ShellExecute(NULL,NULL,ExePath,NULL,NULL,SW_RESTORE)){
		//sG[
		LPVOID lpMsgBuf;
		FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER|FORMAT_MESSAGE_FROM_SYSTEM|FORMAT_MESSAGE_IGNORE_INSERTS,NULL,GetLastError(),MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),(LPTSTR)&lpMsgBuf, 0, NULL);

		CString msg;
		msg.Format(IDS_ERROR_CANNOT_EXECUTE,ExePath,lpMsgBuf);
		LocalFree(lpMsgBuf);

		ErrorMessage(msg);
	}
}
#endif //__LFASSIST__

//From http://techtips.belution.com/ja/vc/0012/
void UtilSetAbsoluteForegroundWindow(HWND hWnd)
{
	int nTargetID, nForegroundID;
	DWORD sp_time;

	// tHAOEhEBhE쐬XbhID擾
	nForegroundID = GetWindowThreadProcessId(GetForegroundWindow(), NULL);
	// ړĨEBhE쐬XbhID擾
	nTargetID = GetWindowThreadProcessId(hWnd, NULL );

	// Xbh̃CvbgԂѕt
	AttachThreadInput(nTargetID, nForegroundID, TRUE );  // TRUE Ōѕt

	// ݂̐ݒ sp_time ɕۑ
	SystemParametersInfo( SPI_GETFOREGROUNDLOCKTIMEOUT,0,&sp_time,0);
	// EBhE̐؂ւԂ 0ms ɂ
	SystemParametersInfo( SPI_SETFOREGROUNDLOCKTIMEOUT,0,(LPVOID)0,0);

	// EBhEtHAOEhɎĂ
	SetForegroundWindow(hWnd);

	// ݒɖ߂
	SystemParametersInfo(SPI_SETFOREGROUNDLOCKTIMEOUT,0,&sp_time,0);

	// Xbh̃CvbgԂ؂藣
	AttachThreadInput(nTargetID, nForegroundID, FALSE );  // FALSE Ő؂藣
}

//z̒Ɏw肳ꂽL΂̈ʒuԂ
int UtilCheckNumberArray(const int *lpcArray,int size,int c)
{
	for(int i=0;i<size;i++){
		if(lpcArray[i]==c)return i;
	}
	return -1;
}

//t@Cw肵2̏[]邩ǂ;ۂD
bool UtilPathAcceptSpec(LPCTSTR lpszPath,const CString& strDeny,const CString &strAccept,bool bDenyOnly)
{
	for(int i=0;i<2;i++){
		if(bDenyOnly&&i==1){
			//ۂ邩ǂ̂݃`FbN
			return true;
		}
		//i=0:ۂ̃`FbN,i=1:̃`FbN
		bool bAccepted=(i==0?false:true);
		const CString& strBuf=(i==0?strDeny:strAccept);
		int Index=0,CopyFrom=0;

		while(true){
			Index=strBuf.Find(_T(';'),Index);
			CString strMatchSpec;
			if(-1==Index){
				strMatchSpec=strBuf.Mid(CopyFrom);
			}
			else{
				strMatchSpec=strBuf.Mid(CopyFrom,Index-CopyFrom);
			}
			if(!strMatchSpec.IsEmpty()){	//gqmF
				strMatchSpec.Insert(0,_T("*"));	//.ext->*.ext
				if(PathMatchSpec(lpszPath,strMatchSpec)){
					return bAccepted;
				}
			}
			if(-1==Index){	//I
				break;
			}
			else{
				Index++;
				CopyFrom=Index;
			}
		}
	}
	//
	return false;
}

//X|Xt@Cǂݎ
bool UtilReadFromResponceFile(LPCTSTR lpszRespFile,UTIL_CODEPAGE uSrcCodePage,std::list<CString> &FileList)
{
	ASSERT(lpszRespFile);
	if(!lpszRespFile)return false;
	if(!PathFileExists(lpszRespFile))return false;

	HANDLE hFile=CreateFile(lpszRespFile,GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
	if(INVALID_HANDLE_VALUE==hFile)return false;

	//4GBzt@C͈Ȃ
	const DWORD dwSize=GetFileSize(hFile,NULL);
	std::vector<BYTE> cReadBuffer;
	cReadBuffer.resize(dwSize+2);
	DWORD dwRead;
	//---ǂݍ
	if(!ReadFile(hFile,&cReadBuffer[0],dwSize,&dwRead,NULL)||dwSize!=dwRead){
		CloseHandle(hFile);
		return false;
	}
	CloseHandle(hFile);

	//---R[hϊ
	//I[ǉ
	switch(uSrcCodePage){
	case UTILCP_SJIS:
	case UTILCP_UTF8:	//FALLTHROUGH
		cReadBuffer[dwSize]='\0';
		break;
	case UTILCP_UTF16:
		*((LPWSTR)&cReadBuffer[dwSize])=L'\0';
		break;
	default:
		ASSERT(!"This code canno be run");
		return false;
	}
	//R[hϊ
	CString strBuffer;
	if(!UtilToUNICODE(strBuffer,&cReadBuffer[0],cReadBuffer.size(),uSrcCodePage))return false;

	LPCTSTR p=strBuffer;
	const LPCTSTR end=p+strBuffer.GetLength()+1;
	//
	CString strLine;
	for(;p!=end;p++){
		if(*p==_T('\n')||*p==_T('\r')||*p==_T('\0')){
			if(!strLine.IsEmpty()){
				CPath tmpPath(strLine);
				tmpPath.UnquoteSpaces();	//""O
				FileList.push_back(tmpPath);
			}
			strLine.Empty();
		}
		else 
			strLine+=*p;
	}
	return true;
}

//INIɐ𕶎Ƃď
BOOL UtilWritePrivateProfileInt(LPCTSTR lpAppName,LPCTSTR lpKeyName,LONG nData,LPCTSTR lpFileName)
{
	TCHAR Buffer[32]={0};
	wsprintf(Buffer,_T("%ld"),nData);
	return ::WritePrivateProfileString(lpAppName,lpKeyName,Buffer,lpFileName);
}

#ifndef __LFASSIST__
//tH_t@C(fBNg͏)ċA
bool UtilRecursiveEnumFile(LPCTSTR lpszRoot,std::list<CString> &rFileList)
{
	CFindFile cFindFile;
	TCHAR szPath[_MAX_PATH+1];
	_tcsncpy_s(szPath,lpszRoot,_MAX_PATH);
	PathAppend(szPath,_T("*"));

	BOOL bContinue=cFindFile.FindFile(szPath);
	while(bContinue){
		if(!cFindFile.IsDots()){
			if(cFindFile.IsDirectory()){
				UtilRecursiveEnumFile(cFindFile.GetFilePath(),rFileList);
			}else{
				rFileList.push_back(cFindFile.GetFilePath());
			}
		}
		bContinue=cFindFile.FindNextFile();
	}

	return !rFileList.empty();
}
#endif//__LFASSIST__

//INIɎw肳ꂽZNVȂtrueԂ
bool UtilCheckINISectionExists(LPCTSTR lpAppName,LPCTSTR lpFileName)
{
	TCHAR szBuffer[10];
	DWORD dwRead=GetPrivateProfileSection(lpAppName,szBuffer,9,lpFileName);
	return dwRead>0;
}

#ifndef __LFASSIST__
class CInputDialog : public CDialogImpl<CInputDialog>,public CWinDataExchange<CInputDialog>
{
protected:
	CString &strInput;
	CString strMessage;
public:
	enum {IDD = IDD_DIALOG_INPUT};
	CInputDialog(LPCTSTR lpszMessage,CString &str):strInput(str),strMessage(lpszMessage){}

	// DDX}bv
	BEGIN_DDX_MAP(CInputDialog)
		DDX_TEXT(IDC_EDIT_INPUT,strInput)
	END_DDX_MAP()

	// bZ[W}bv
	BEGIN_MSG_MAP_EX(CInputDialog)
		MSG_WM_INITDIALOG(OnInitDialog)
		COMMAND_ID_HANDLER_EX(IDOK, OnButton)
		COMMAND_ID_HANDLER_EX(IDCANCEL, OnButton)
	END_MSG_MAP()

	LRESULT OnInitDialog(HWND hWnd, LPARAM lParam){
		//bZ[Wݒ
		CStatic cStatic=GetDlgItem(IDC_STATIC_MESSAGE);
		cStatic.SetWindowText(strMessage);

		//DDXݒ
		DoDataExchange(FALSE);
		return TRUE;
	}
	void OnButton(UINT uNotifyCode, int nID, HWND hWndCtl){
		//DDXݒ
		DoDataExchange(TRUE);
		EndDialog(nID);
	}
};

//͂
bool UtilInputText(LPCTSTR lpszMessage,CString &strInput)
{
	CInputDialog dlg(lpszMessage,strInput);
	return IDOK==dlg.DoModal();
}

#endif//__LFASSIST__

//tpX΃pX̎擾
PATHERROR UtilGetCompletePathName(CString &_FullPath,LPCTSTR lpszFileName)
{
	ASSERT(lpszFileName&&_tcslen(lpszFileName)>0);
	if(!lpszFileName||_tcslen(lpszFileName)<=0){
		TRACE(_T("t@Cw肳ĂȂ\n"));
		return PATHERROR_INVALID;
	}

	//---΃pX擾
	TCHAR szAbsPath[_MAX_PATH+1]={0};
	{
		TCHAR Buffer[_MAX_PATH+1]={0};	//[gǂ̃`FbNs
		_tcsncpy_s(Buffer,lpszFileName,_MAX_PATH);
		PathAddBackslash(Buffer);
		if(PathIsRoot(Buffer)){
			//hCuw肳ĂꍇA
			//_tfullpath͂̃hCũJgfBNg擾Ă܂
			_tcsncpy_s(szAbsPath,lpszFileName,_MAX_PATH);
		}
		else if(!_tfullpath(szAbsPath,lpszFileName,_MAX_PATH)){
			TRACE(_T("΃pX擾s\n"));
			return PATHERROR_ABSPATH;
		}
	}

	if(!PathFileExists(szAbsPath)&&!PathIsDirectory(szAbsPath)){
		//pXt@C̓fBNgƂđ݂ȂȂAG[Ƃ
		TRACE(_T("t@C݂Ȃ\n"));
		return PATHERROR_NOTFOUND;
	}
	if(!GetLongPathName(szAbsPath,szAbsPath,_MAX_PATH)){
		TRACE(_T("Ot@C擾s\n"));
		return PATHERROR_LONGNAME;
	}
	_FullPath=szAbsPath;
	return PATHERROR_NONE;
}

//΃pX̎擾
bool UtilGetAbsPathName(CString &_FullPath,LPCTSTR lpszFileName)
{
	ASSERT(lpszFileName&&_tcslen(lpszFileName)>0);
	if(!lpszFileName||_tcslen(lpszFileName)<=0){
		TRACE(_T("t@Cw肳ĂȂ\n"));
		return false;
	}

	//---΃pX擾
	TCHAR szAbsPath[_MAX_PATH+1]={0};
	{
		TCHAR Buffer[_MAX_PATH+1]={0};	//[gǂ̃`FbNs
		_tcsncpy_s(Buffer,lpszFileName,_MAX_PATH);
		PathAddBackslash(Buffer);
		if(PathIsRoot(Buffer)){
			//hCuw肳ĂꍇA
			//_tfullpath͂̃hCũJgfBNg擾Ă܂
			_tcsncpy_s(szAbsPath,lpszFileName,_MAX_PATH);
		}
		else if(!_tfullpath(szAbsPath,lpszFileName,_MAX_PATH)){
			TRACE(_T("΃pX擾s\n"));
			return false;
		}
	}

	_FullPath=szAbsPath;
	return true;
}

#ifndef __LFASSIST__
//ChJ[h̓WJ
bool UtilPathExpandWild(std::list<CString> &r_outList,const std::list<CString> &r_inList)
{
	std::list<CString> tempList;
	std::list<CString>::const_iterator ite=r_inList.begin();
	const std::list<CString>::const_iterator end=r_inList.end();
	for(;ite!=end;++ite){
		if(-1==(*ite).FindOneOf(_T("*?"))){	//ChWJ\ȕ͂Ȃ
			tempList.push_back(*ite);
		}else{
			//ChWJ
			CFindFile cFindFile;
			BOOL bContinue=cFindFile.FindFile(*ite);
			while(bContinue){
				if(!cFindFile.IsDots()){
					tempList.push_back(cFindFile.GetFilePath());
				}
				bContinue=cFindFile.FindNextFile();
			}
		}
	}
	r_outList=tempList;
	return true;
}


bool UtilPathExpandWild(std::list<CString> &r_outList,const CString &r_inParam)
{
	std::list<CString> tempList;
	if(-1==r_inParam.FindOneOf(_T("*?"))){	//ChWJ\ȕ͂Ȃ
		tempList.push_back(r_inParam);
	}else{
		//ChWJ
		CFindFile cFindFile;
		BOOL bContinue=cFindFile.FindFile(r_inParam);
		while(bContinue){
			if(!cFindFile.IsDots()){
				tempList.push_back(cFindFile.GetFilePath());
			}
			bContinue=cFindFile.FindNextFile();
		}
	}
	r_outList=tempList;
	return true;
}
#endif// __LFASSIST__


//pX̃fBNgo
void UtilPathGetDirectoryPart(CString &str)
{
	LPTSTR lpszBuf=str.GetBuffer(_MAX_PATH+1);
	PathRemoveFileSpec(lpszBuf);
	PathAddBackslash(lpszBuf);
	str.ReleaseBuffer();
}

//̃vÕt@CԂ
LPCTSTR UtilGetModulePath()
{
	static TCHAR s_szExePath[_MAX_PATH+1]={0};
	if(s_szExePath[0]!=_T('\0'))return s_szExePath;

	GetModuleFileName(GetModuleHandle(NULL), s_szExePath, _MAX_PATH);	//{̂̃pX擾
	return s_szExePath;
}

//̃vÔĂfBNg̃pXԂ
LPCTSTR UtilGetModuleDirectoryPath()
{
	static TCHAR s_szDirPath[_MAX_PATH+1]={0};
	if(s_szDirPath[0]!=_T('\0'))return s_szDirPath;

	GetModuleFileName(GetModuleHandle(NULL), s_szDirPath, _MAX_PATH);	//{̂̃pX擾
	PathRemoveFileSpec(s_szDirPath);
	return s_szDirPath;
}

#ifndef __LFASSIST__
//Kw̃fBNgCɍ쐬
BOOL UtilMakeSureDirectoryPathExists(LPCTSTR _lpszPath)
{
#if defined(_UNICODE)||defined(UNICODE)
	CPath path(_lpszPath);
	path.RemoveFileSpec();
	path.AddBackslash();

	//TODO:UNICODEł݂̂Ń`FbNĂ̂ANSIrhɂ͓KXׂ
	CString tmp(path);
	if(-1!=tmp.Find(_T(" \\"))||-1!=tmp.Find(_T(".\\"))){	//pXƂďłȂt@C
		return FALSE;
	}

	//UNICODEł݂̂ŕKvȃ`FbN
	if(path.IsRoot())return TRUE;	//hCu[gȂ쐬Ȃ(łȂ)

	int nRet=SHCreateDirectoryEx(NULL,path,NULL);
	switch(nRet){
	case ERROR_SUCCESS:
		return TRUE;
	case ERROR_ALREADY_EXISTS:
		if(path.IsDirectory())return TRUE;	//łɃfBNgꍇZ[tƂ
		else return FALSE;
	default:
		return FALSE;
	}
#else//defined(_UNICODE)||defined(UNICODE)
  #pragma comment(lib, "Dbghelp.lib")
	return MakeSureDirectoryPathExists(_lpszPath);
#endif//defined(_UNICODE)||defined(UNICODE)
}
#endif// __LFASSIST__

//R}hC擾(Ԃ)
int UtilGetCommandLineParams(std::vector<CString> &rParams)
{
#if defined(_UNICODE)||defined(UNICODE)
	int nArgc=0;
	LPWSTR *lplpArgs=CommandLineToArgvW(GetCommandLine(), &nArgc);
	rParams.resize(nArgc);
	for(int i=0;i<nArgc;i++){
		rParams[i]=lplpArgs[i];
	}
	LocalFree(lplpArgs);
	return nArgc;
#else//defined(_UNICODE)||defined(UNICODE)
	rParams.resize(__argc);
	for(int i=0;i<__argc;i++){
		rParams[i]=__argv[i];
	}
	return __argc;
#endif//defined(_UNICODE)||defined(UNICODE)
}

//MFCX^CCFileDialog̃tB^[
void UtilMakeFilterString(LPCTSTR lpszIn,LPTSTR lpszOut,int outSize)
{
	ASSERT(outSize>=2);
	if(outSize<2)return;
	_tcsncpy_s(lpszOut,outSize,lpszIn,outSize);
	lpszOut[outSize-1]=_T('\0');
	lpszOut[outSize-2]=_T('\0');

	LPTSTR lpChar=lpszOut;
	for(;*lpChar!=_T('\0');lpChar++){
#if !defined(_UNICODE)&&!defined(UNICODE)
		if(_MBC_SINGLE==_mbsbtype((LPCBYTE)lpChar,0))
#endif
			if(*lpChar==_T('|')){
				*lpChar=_T('\0');
			}
	}
	*lpChar++;
	*lpChar=_T('\0');
}

//TCHARt@CSJISt@CɕϊBϊłȂꍇɂ́AfalseԂ
bool UtilPathT2A(CStringA &strA,LPCTSTR lpPath,bool bOnDisk)
{
#if defined(_UNICODE)||defined(UNICODE)
	CStringA strTemp(lpPath);
	if(strTemp==lpPath){
		//ϊł
		strA=strTemp;
		return true;
	}
	if(!bOnDisk){
		//fBXÑt@Cł͂Ȃ̂ŁAȍ~̑֎i͎Ȃ
		return false;
	}
	//V[gt@CőpĂ݂
	WCHAR szPath[_MAX_PATH+1];
	GetShortPathNameW(lpPath,szPath,_MAX_PATH+1);

	//SJISɕϊłĂ邩ǂ`FbN
	return UtilPathT2A(strA,szPath,false);

#else//defined(_UNICODE)||defined(UNICODE)
	//SJIŜ܂
	strA=lpPath;
	return true;
#endif//defined(_UNICODE)||defined(UNICODE)
}

//TCHARt@CSJISt@Cŕ\ł邩`FbN
bool UtilCheckT2A(LPCTSTR lpPath)
{
#if defined(_UNICODE)||defined(UNICODE)
	//ϊłĂ邩ǂ`FbN
	CStringA strTempA(lpPath);
	CStringW strTempW(strTempA);
	return (strTempW==lpPath);
#else//defined(_UNICODE)||defined(UNICODE)
	//SJIŜ܂
	return true;
#endif//defined(_UNICODE)||defined(UNICODE)
}



//KȕR[h->UNICODE
bool UtilToUNICODE(CString &strRet,LPCBYTE lpcByte,DWORD dwSize,UTIL_CODEPAGE uSrcCodePage)
{
#if defined(_UNICODE)||defined(UNICODE)
	switch(uSrcCodePage){
	case UTILCP_SJIS:
		strRet=CStringA((LPCSTR)lpcByte);
		return true;
	case UTILCP_UTF16:
		if(*((LPCWSTR)lpcByte)==0xFEFF){
			//UTF16LE
			strRet=((LPCWSTR)lpcByte)+1;
		}else if(*((LPCWSTR)lpcByte)==0xFFFE){
			//UTF16BE
			//GfBAϊ
			std::vector<BYTE> cArray(dwSize-2);
			_swab((char*)const_cast<LPBYTE>(lpcByte+2),(char*)&cArray[0],dwSize-2);
			strRet=(LPCWSTR)&cArray[0];
			return true;
		}
		else{
			strRet=(LPCWSTR)lpcByte;
		}
		return true;
	case UTILCP_UTF8:
		{
			if(lpcByte[0]==0xEF && lpcByte[1]==0xBB && lpcByte[2]==0xBF){	//BOM check
				lpcByte+=3;
			}
			std::vector<wchar_t> buf(::MultiByteToWideChar(CP_UTF8,0,(LPCSTR)lpcByte,-1,NULL,0));	//obt@m
			//ϊ
			if(!::MultiByteToWideChar(CP_UTF8,0,(LPCSTR)lpcByte,-1,&buf[0],buf.size())){
				TRACE(_T("R[hϊs(UTF8->UTF16)"));
				return false;
			}
			strRet=(LPCWSTR)&buf[0];
			return true;
		}
	default:
		ASSERT(!"This code cannot be run");
		return false;
	}
#else//defined(_UNICODE)||defined(UNICODE)
#error("not implemented")
	return false;
#endif//defined(_UNICODE)||defined(UNICODE)
}

//UNICODE->UTF8
bool UtilToUTF8(std::vector<BYTE> &cArray,const CStringW &strSrc)
{
#if defined(_UNICODE)||defined(UNICODE)
	cArray.resize(::WideCharToMultiByte(CP_UTF8,0,strSrc,-1,NULL,0,NULL,NULL));	//obt@m
	//ϊ
	if(!::WideCharToMultiByte(CP_UTF8,0,strSrc,-1,(LPSTR)&cArray[0],cArray.size(),NULL,NULL)){
		TRACE(_T("R[hϊs(UTF16->UTF8)"));
		return false;
	}
	return true;
#else//defined(_UNICODE)||defined(UNICODE)
#error("not implemented")
	return false;
#endif//defined(_UNICODE)||defined(UNICODE)
}

inline bool between(WCHAR a,WCHAR begin,WCHAR end){
	return (begin<=a && a<=end);
}

//UNICODEƂĈSȂtrue
bool UtilIsSafeUnicode(LPCTSTR lpChar)
{
#if defined(_UNICODE)||defined(UNICODE)
	ASSERT(lpChar);
	if(!lpChar){
		return true;
	}
	const static WCHAR chars[]={
		0x001e,
		0x001f,
		0x00ad,
		0xFEFF,
		0xFFF9,
		0xFFFA,
		0xFFFB,
		0xFFFE,
	};
	const static UINT len=sizeof(chars)/sizeof(chars[0]);
	for(;*lpChar!=L'\0';lpChar++){
		WCHAR c=*lpChar;
		//PƕƂ̔r
		for(UINT i=0;i<len;i++){
			if(c==chars[i])return false;
		}

		//͈͂̂镶Ƃ̔r
		if(between(c,0x200b,0x200f))return false;
		if(between(c,0x202a,0x202e))return false;
		if(between(c,0x2060,0x2063))return false;
		if(between(c,0x206a,0x206f))return false;
	}
	return true;

#else//defined(_UNICODE)||defined(UNICODE)
	return true;
#endif//defined(_UNICODE)||defined(UNICODE)
}

//^ꂽt@C}`{[ɂƌȂȂtrueԂ
bool UtilIsMultiVolume(LPCTSTR lpszPath,CString &r_strFindParam)
{
	//
	r_strFindParam.Empty();

	CPath strPath(lpszPath);
	if(strPath.IsDirectory())return false;	//fBNgȂ疳ɕԂ

	strPath.StripPath();	//t@Ĉ݂
	int nExt=strPath.FindExtension();	//gq.̈ʒu
	if(-1==nExt)return false;	//gq͌炸

	CString strExt((LPCTSTR)strPath+nExt);
	strExt.MakeLower();	//
	if(strExt==_T(".rar")){
		//---RAR
		if(strPath.MatchSpec(_T("*.part*.rar"))){
			//̍쐬
			CPath tempPath(lpszPath);
			tempPath.RemoveExtension();	//.rar̍폜
			tempPath.RemoveExtension();	//.part??̍폜
			tempPath.AddExtension(_T(".part*.rar"));

			r_strFindParam=(CString)tempPath;
			return true;
		}else{
			return false;
		}
	}/*else if(strExt==_T(".jak")){
		//JACKł͓s\;IWiȂ̂{[Ȃ̂ʂłȂ
		return false;
	}else if(strPath.MatchSpec(_T("*.zip.???"))){		//strExt==_T("zip"))
		//---ZIP
		//{ZIPǂׂ邽߁AŌオǂm߂
		int param=_ttoi((LPCTSTR)strExt+1);
		CString strTmp;
		strTmp.Format(_T(".%3d"),param);
		if(param==strExt){
			//
			//TODO:K\gƂꂵ
			return true;
		}
		//7zقړl
	}*/
	//TODO:gppxƎ̊ȕւlrar̂ݑΉƂ
	return false;
}


//pXɋʂ镔oApXo
void UtilGetBaseDirectory(CString &BasePath,std::list<CString> &PathList)
{
	bool bFirst=true;
	size_t ElementsCount=0;	//ʍڐ
	std::vector<CString> PathElements;	//ʍڂ̔z

	std::list<CString>::iterator ite,end;
	end=PathList.end();
	for(ite=PathList.begin();ite!=end;++ite){
		if(!bFirst&&0==ElementsCount){
			//ɋʂĂvfzɑ݂ȂƂ
			break;
		}

		//efBNg܂łŏIpX
		TCHAR Path[_MAX_PATH+1];
		FILL_ZERO(Path);
		_tcsncpy_s(Path,*ite,_MAX_PATH);
		PathRemoveFileSpec(Path);
		PathAddBackslash(Path);

		CString buffer;
		size_t iElement=0;	//vĂpX̗vf̃JEgp([v)
		size_t iIndex=0;	//pX̃̕CfbNX
		const size_t Length=_tcslen(Path);
		for(;iIndex<Length;iIndex++){
#if !defined(_UNICODE)&&!defined(UNICODE)
			if(_MBC_SINGLE==_mbsbtype((const unsigned char *)Path,iIndex)){
#endif
				if(_T('\\')==Path[iIndex]){
					//ȂpXlߍ݁AłȂΗvfr
					if(bFirst){
//						TRACE(_T("Feed:First:%s\n"),buffer);
						PathElements.push_back(buffer);
						buffer.Empty();
						continue;
					}
					else{
						//啶ʂɔr
						if(0==PathElements[iElement].CompareNoCase(buffer)){
//							TRACE(_T("pXvfv\n"));
							//vfʂĂ邤OK
							iElement++;
							if(iElement>=ElementsCount)break;
							else{
								buffer.Empty();
								continue;
							}
						}
						else
						{
							//vf炷
							//0IWiԖڂŕsvȂi܂ňv
							ElementsCount=iElement;
//							TRACE(_T("sv:iElement=%d\n"),iElement);
							break;
						}
					}
				}
#if !defined(_UNICODE)&&!defined(UNICODE)
			}
#endif
			buffer+=Path[iIndex];
		}
		if(bFirst){
			bFirst=false;
			ElementsCount=PathElements.size();
//			TRACE(_T("ElementsCount=%d\n"),ElementsCount);
		}
		else if(ElementsCount>iElement){
			//pXZꍇAsvȂ̂܂܏Iꍇ
			ElementsCount=iElement;
//			TRACE(_T("pXZ:%s:iElement=%d\n"),*ite,iElement);
		}
	}

	BasePath.Empty();
	for(size_t i=0;i<ElementsCount;i++){
		BasePath+=PathElements[i];
		BasePath+=_T("\\");
	}
	TRACE(_T("BasePath=%s\n"),BasePath);
}

//݂OSWindowsVista͂ȏȂtrueԂ
bool UtilIsOSVistaOrHigher()
{
	OSVERSIONINFO osv={0};
	osv.dwOSVersionInfoSize=sizeof(osv);
	if(!::GetVersionEx(&osv)){
		ASSERT(!"GetVersionEx failed");
		return false;
	}
	if(osv.dwMajorVersion>6||(osv.dwMajorVersion==6&&osv.dwMinorVersion>=0))return true;
	return false;
}

#ifndef __LFASSIST__
//W̐ݒt@C̃pX擾
//bUserCommon̓[U[Ԃŋʐݒgꍇtrue
//lpszDirApplicationDataɓƂɕKvȃfBNg
//lpszFile͒Tt@C
void UtilGetDefaultFilePath(CString &strPath,LPCTSTR lpszDir,LPCTSTR lpszFile,bool &bUserCommon)
{
	//---[U[Ԃŋʂ̐ݒp
	//LhaForgetH_ƓꏊINIΎgp
	{
		TCHAR szCommonIniPath[_MAX_PATH+1]={0};
		_tcsncpy_s(szCommonIniPath,UtilGetModuleDirectoryPath(),_MAX_PATH);
		PathAppend(szCommonIniPath,lpszFile);
		if(PathFileExists(szCommonIniPath)){
			//ʐݒ
			bUserCommon=true;
			strPath=szCommonIniPath;
			TRACE(_T("Common INI(Old Style) '%s' found.\n"),strPath);
			return;
		}
	}
	//CSIDL_COMMON_APPDATAINIΎgp
	{
		TCHAR szCommonIniPath[_MAX_PATH+1]={0};
		SHGetFolderPath(NULL,CSIDL_COMMON_APPDATA|CSIDL_FLAG_CREATE,NULL,SHGFP_TYPE_CURRENT,szCommonIniPath);
		PathAppend(szCommonIniPath,lpszDir);
		PathAppend(szCommonIniPath,lpszFile);
		if(PathFileExists(szCommonIniPath)){
			//ʐݒ
			bUserCommon=true;
			strPath=szCommonIniPath;
			TRACE(_T("Common INI '%s' found.\n"),strPath);
			return;
		}
	}

	//--------------------

	//---[U[ʐݒp
	//LhaForgeCXg[tH_ȉɃt@C݂ꍇAgp
	{
		//[U[擾
		TCHAR UserName[UNLEN+1]={0};
		DWORD Length=UNLEN;
		GetUserName(UserName,&Length);

		TCHAR szIniPath[_MAX_PATH+1];
		_tcsncpy_s(szIniPath,UtilGetModuleDirectoryPath(),_MAX_PATH);
		PathAppend(szIniPath,UserName);
		PathAddBackslash(szIniPath);
		//MakeSureDirectoryPathExists(szIniPath);

		PathAppend(szIniPath,lpszFile);

		if(PathFileExists(szIniPath)){
			bUserCommon=false;
			strPath=szIniPath;
			TRACE(_T("Personal INI(Old Style) '%s' found.\n"),strPath);
			return;
		}
	}
	//---ftHg
	//CSIDL_APPDATAINIΎgp:Vistał͂ȊO̓ANZXsɂȂ\
	TCHAR szIniPath[_MAX_PATH+1]={0};
	SHGetFolderPath(NULL,CSIDL_APPDATA|CSIDL_FLAG_CREATE,NULL,SHGFP_TYPE_CURRENT,szIniPath);
	PathAppend(szIniPath,lpszDir);
	PathAddBackslash(szIniPath);
	UtilMakeSureDirectoryPathExists(szIniPath);
	PathAppend(szIniPath,lpszFile);
	bUserCommon=false;
	strPath=szIniPath;
	TRACE(_T("Personal INI '%s' found.\n"),strPath);
	return;
}


BOOL UtilIsWow64()
{
	typedef BOOL (WINAPI *LPFN_ISWOW64PROCESS) (HANDLE, PBOOL);

	BOOL bIsWow64 = FALSE;

	LPFN_ISWOW64PROCESS fnIsWow64Process = (LPFN_ISWOW64PROCESS)GetProcAddress(GetModuleHandle(_T("kernel32")),"IsWow64Process");

	if(fnIsWow64Process){
		if(!fnIsWow64Process(GetCurrentProcess(),&bIsWow64)){
			return FALSE;
		}
	}
	return bIsWow64;
}


#endif	//__LFASSIST__

